import javalang, requests, re, json, os, pprint

from parsing import common

locationTable = {}

#Dimensional Corridor
locationTable["Angel Shield"] = {"mapName": "dimensional_corridor", "subMapXY": [318, 1135], "locationName": "Marduk's Room", "sectionName": "Angel Shield location"}
locationTable["Coin: Dimensional"] = {"mapName": "dimensional_corridor", "subMapXY": [1240, 2465], "locationName": "Anshar's Room", "sectionName": "Coin Chest in top right wall"}
locationTable["Map (Dimensional Corridor)"] = {"mapName": "dimensional_corridor", "subMapXY": [1230, 2980], "locationName": "Kishar's Room", "sectionName": "Dimensional Map location"}
locationTable["beolamu.exe"] = {"mapName": "dimensional_corridor", "subMapXY": [960, 1165], "locationName": "Mushnahhu's Room", "sectionName": "Scan the room"}
locationTable["Ankh Jewel (Dimensional Corridor)"] = {"mapName": "dimensional_corridor", "subMapXY": [2140, 1850], "locationName": "Mushussu's Room", "sectionName": "Mushussu's item"}
locationTable["Sacred Orb (Dimensional Corridor)"] = {"mapName": "dimensional_corridor", "subMapXY": [1440, 260], "locationName": "Anu's Room", "sectionName": "Dimensional Orb location"}
locationTable["Magatama Jewel"] = {"mapName": "dimensional_corridor", "subMapXY": [1600, 1300], "locationName": "Tiamat's Room", "sectionName": "Tiamat's Item"}
locationTable["Event: Tiamat Defeated"] = {"mapName": "dimensional_corridor", "subMapXY": [1596, 1057], "locationName": "Tiamat's Room", "sectionName": "Tiamat", "hostedItem": "Tiamat"}

#Chamber of Birth
locationTable["Map (Chamber of Birth)"] = {"mapName": "chamber_of_birth", "subMapXY": [695, 1850], "locationName": "Brahma's Room", "sectionName": "Birth Map location"}
locationTable["Shop 17 (Birth)"] = {"mapName": "chamber_of_birth", "subMapXY": [1357, 1780], "locationName": "Mud Man Qubert's shop", "sectionName": "Store Stock"}
locationTable["Dimensional Key"] = {"mapName": "chamber_of_birth", "subMapXY": [2470, 2255], "locationName": "Asura's Room", "sectionName": "Dimensional Key location"}
locationTable["Pochette Key"] = {"mapName": "chamber_of_birth", "subMapXY": [3770, 2090], "locationName": "Skanda's Room", "sectionName": "Skanda's Item"}
locationTable["Coin: Birth (Dance)"] = {"mapName": "chamber_of_birth", "subMapXY": [2817, 2740], "locationName": "Hanuman's Room", "sectionName": "Coin chest nehind pillar"}
locationTable["Coin: Birth (Ninja)"] = {"mapName": "chamber_of_birth", "subMapXY": [2680, 575], "locationName": "Surrounding Wall of Spikes", "sectionName": "Kill a Ninja"}
locationTable["Vessel"] = {"mapName": "chamber_of_birth", "subMapXY": [3780, 895], "locationName": "Surrounding Wall of Spikes", "sectionName": "Golden glow reflects the beam"}
locationTable["Perfume"] = {"mapName": "chamber_of_birth", "subMapXY": [4430, 655], "locationName": "Shiva's Room", "sectionName": "Wait for Mudman"}
locationTable["Coin: Birth (Southeast)"] = {"mapName": "chamber_of_birth", "subMapXY": [4525, 1855], "locationName": "Vishnu's Room", "sectionName": "Coin chest at bottom left"}
locationTable["Woman Statue"] = {"mapName": "chamber_of_birth", "subMapXY": [5170, 1530], "locationName": "Parvati's Room", "sectionName": "Woman Statue location"}

#Endless Corridor
locationTable["Shop 22 (Endless)"] = {"mapName": "endless_corridor", "subMapXY": [1500, 340], "locationName": "Knimare's shop", "sectionName": "Store Stock"}
locationTable["Map (Endless Corridor)"] = {"mapName": "endless_corridor", "subMapXY": [35, 255], "locationName": "First Endless Corridor", "sectionName": "Loop First Corridor"}
locationTable["Key Sword"] = {"mapName": "endless_corridor", "subMapXY": [1640, 815], "locationName": "Second Endless Corridor", "sectionName": "Attack Weapon Seal"}
locationTable["Twin Statue"] = {"mapName": "endless_corridor", "subMapXY": [95, 1060], "locationName": "Third Endless Corridor", "sectionName": "Twin Statue location"}
locationTable["Coin: Endless"] = {"mapName": "endless_corridor", "subMapXY": [1490, 1220], "locationName": "Third Endless Corridor", "sectionName": "Coin Chest in middle left wall"}

#Chamber of Extinction
locationTable["Map (Chamber of Extinction)"] = {"mapName": "chamber_of_extinction", "subMapXY": [858, 1295], "locationName": "Darkness Approach", "sectionName": "Extinction Map location"}
locationTable["Coin: Extinction"] = {"mapName": "chamber_of_extinction", "subMapXY": [1050, 1295], "locationName": "Darkness Approach", "sectionName": "Coin chest on the side with candle of light"}
locationTable["Sacred Orb (Chamber of Extinction)"] = {"mapName": "chamber_of_extinction", "subMapXY": [1320, 1055], "locationName": "Darkness Approach", "sectionName": "Floor switch at top right of room (Extinction Orb location)"}
locationTable["Chakram"] = {"mapName": "chamber_of_extinction", "subMapXY": [1685, 1775], "locationName": "Mural Depicting the Power of Words", "sectionName": "Hekatonkheires' item (Chakram location)"}
locationTable["mantra.exe"] = {"mapName": "chamber_of_extinction", "subMapXY": [2240, 1600], "locationName": "Mural Depicting the Power of Words", "sectionName": "Scan the lit up mural"}
locationTable["Life Seal"] = {"mapName": "chamber_of_extinction", "subMapXY": [3800, 1700], "locationName": "Mural of Light", "sectionName": "Go through the below wall"}
locationTable["Shop 16 (Extinction)"] = {"mapName": "chamber_of_extinction", "subMapXY": [4776, 740], "locationName": "Combaker's shop", "sectionName": "Store Stock"}
locationTable["Event: Palenque Defeated"] = {"mapName": "chamber_of_extinction", "subMapXY": [5429, 1364], "locationName": "Palenque's Room", "sectionName": "Palenque", "hostedItem": "Palenque"}

#Tower of the Goddess
locationTable["Eye of Truth"] = {"mapName": "tower_of_the_goddess", "subMapXY": [325, 2255], "locationName": "Verdandi's Tower", "sectionName": "Eye of Truth location"}
locationTable["Shop 13 (Goddess)"] = {"mapName": "tower_of_the_goddess", "subMapXY": [378, 1380], "locationName": "Energetic Belmont's shop", "sectionName": "Store Stock"}
locationTable["Spaulder"] = {"mapName": "tower_of_the_goddess", "subMapXY": [1780, 145], "locationName": "Path to Life", "sectionName": "Key Fairy"}
locationTable["Coin: Goddess (Shield)"] = {"mapName": "tower_of_the_goddess", "subMapXY": [2735, 415], "locationName": "Path to Power", "sectionName": "Coin chest left of bottom pot"}
locationTable["Plane Model"] = {"mapName": "tower_of_the_goddess", "subMapXY": [2240, 675], "locationName": "Skuld's Tower", "sectionName": "Foothold in front of statues"}
locationTable["Flail Whip"] = {"mapName": "tower_of_the_goddess", "subMapXY": [1600, 1855], "locationName": "Scales of the Heart", "sectionName": "Balance the Spirits (2xR, 3xL, 2xR, stand left)"}
locationTable["Coin: Goddess (Fairy)"] = {"mapName": "tower_of_the_goddess", "subMapXY": [1200, 2015], "locationName": "Urd's Tower", "sectionName": "Floor switch next to pipe"}
locationTable["Map (Tower of the Goddess)"] = {"mapName": "tower_of_the_goddess", "subMapXY": [1865, 3770], "locationName": "Anterior Chamber", "sectionName": "Behind collapsed tower"}

#Graveyard of the Giants
locationTable["Shop 7 (Graveyard)"] = {"mapName": "graveyard_of_giants", "subMapXY": [120, 420], "locationName": "Giant Mopiran's shop", "sectionName": "Store Stock"}
locationTable["Silver Shield"] = {"mapName": "graveyard_of_giants", "subMapXY": [1060, 655], "locationName": "White Silver Altar", "sectionName": "Break the floor from above"}
locationTable["Coin: Graveyard"] = {"mapName": "graveyard_of_giants", "subMapXY": [1845, 95], "locationName": "First Tomb", "sectionName": "Coin Chest on the cliff top right"}
locationTable["Map (Graveyard of the Giants)"] = {"mapName": "graveyard_of_giants", "subMapXY": [2345, 1055], "locationName": "Path to the Graveyard", "sectionName": "Drop the ice above"}
locationTable["Gauntlet"] = {"mapName": "graveyard_of_giants", "subMapXY": [2075, 1535], "locationName": "Path to the Graveyard", "sectionName": "Gauntlet location"}
locationTable["mirai.exe"] = {"mapName": "graveyard_of_giants", "subMapXY": [1020, 2340], "locationName": "Third Tomb", "sectionName": "Jump to the dias from the left"}
locationTable["emusic.exe"] = {"mapName": "graveyard_of_giants", "subMapXY": [3460, 1695], "locationName": "Altar of Knowledge", "sectionName": "Scan on the Bombed Wall"}
locationTable["Bomb"] = {"mapName": "graveyard_of_giants", "subMapXY": [2880, 1295], "locationName": "Altar of Power", "sectionName": "Kamaitachi's item"}
locationTable["Trap: Graveyard"] = {"mapName": "graveyard_of_giants", "subMapXY": [2515, 2820], "locationName": "Path to the Graveyard", "sectionName": "Monster Trap chest"}

#Gate of Guidance
locationTable["Sacred Orb (Gate of Guidance)"] = {"mapName": "gate_of_guidance", "subMapXY": [2300, 100], "locationName": "Pillars Gate", "sectionName": "Guidance Orb Location"}
locationTable["Treasures"] = {"mapName": "gate_of_guidance", "subMapXY": [1617, 190], "locationName": "Pillars Gate", "sectionName": "Pepper turn in"}
locationTable["Crucifix"] = {"mapName": "gate_of_guidance", "subMapXY": [3060, 900], "locationName": "Heavenly Temple of the Cross", "sectionName": "Offer 3 lights to the heavens"}
locationTable["Shuriken"] = {"mapName": "gate_of_guidance", "subMapXY": [3540, 660], "locationName": "Room of Courage", "sectionName": "Prove thine courage"}
locationTable["Coin: Guidance (One)"] = {"mapName": "gate_of_guidance", "subMapXY": [4140, 900], "locationName": "Room of Courage", "sectionName": "Coin Chest 1"}
locationTable["Coin: Guidance (Two)"] = {"mapName": "gate_of_guidance", "subMapXY": [4300, 720], "locationName": "Room of Courage", "sectionName": "Coin Chest 2"}
locationTable["Map (Gate of Guidance)"] = {"mapName": "gate_of_guidance", "subMapXY": [1760, 1220], "locationName": "Heavenly Corridor", "sectionName": "Guidance Map Location"}
locationTable["Holy Grail"] = {"mapName": "gate_of_guidance", "subMapXY": [1100, 1620], "locationName": "Pit of the Holy Grail", "sectionName": "Block pushing from fake wall"}
locationTable["Coin: Guidance (Trap)"] = {"mapName": "gate_of_guidance", "subMapXY": [1850, 1800], "locationName": "Gate of Giant Faces", "sectionName": "Jump from the trap door"}
locationTable["Shop 4 (Guidance)"] = {"mapName": "gate_of_guidance", "subMapXY": [858, 2662], "locationName": "Penadvent of ghost shop", "sectionName": "Store Stock"}
locationTable["Ankh Jewel (Gate of Guidance)"] = {"mapName": "gate_of_guidance", "subMapXY": [2277, 2340], "locationName": "Cliff of Radiance", "sectionName": "4 extinction event"}
locationTable["yagostr.exe"] = {"mapName": "gate_of_guidance", "subMapXY": [35, 1300], "locationName": "Door to Eden", "sectionName": "Come from Ruin Door"}
locationTable["Event: Amphisbaena Defeated"] = {"mapName": "gate_of_guidance", "subMapXY": [2882, 2326], "locationName": "Amphisbaena's Room", "sectionName": "Amphisbaena", "hostedItem": "Amphisbaena"}

#Gate of Illusion
locationTable["Coin: Illusion (Spikes)"] = {"mapName": "gate_of_illusion", "subMapXY": [3305, 2660], "locationName": "Entrance of Illusion", "sectionName": "Coin chest in the wall above spikes"}
locationTable["Trap: Exploding"] = {"mapName": "gate_of_illusion", "subMapXY": [2210, 2085], "locationName": "Fool's Confusion Corridor", "sectionName": "Trap Chest"}
locationTable["Map (Gate of Illusion)"] = {"mapName": "gate_of_illusion", "subMapXY": [2100, 2170], "locationName": "Fool's Confusion Corridor", "sectionName": "Real chest (Illusion Map loction)"}
locationTable["Pepper"] = {"mapName": "gate_of_illusion", "subMapXY": [3259, 1343], "locationName": "Sacred Lake of the Sky", "sectionName": "Mr. Slushfund's Request (Pepper location)"}
locationTable["Anchor"] = {"mapName": "gate_of_illusion", "subMapXY": [3259, 1343], "locationName": "Sacred Lake of the Sky", "sectionName": "Treasure Turn In", "isChild": True, "childOf": "Pepper"}
locationTable["Mini Doll"] = {"mapName": "gate_of_illusion", "subMapXY": [3700, 2020], "locationName": "Priest Alest", "sectionName": "Mini doll location"}
locationTable["Shop 5 (Illusion)"] = {"mapName": "gate_of_illusion", "subMapXY": [580, 1225], "locationName": "Mover Athleland's shop", "sectionName": "Store Stock"}
locationTable["Fairy Clothes"] = {"mapName": "gate_of_illusion", "subMapXY": [60, 1620], "locationName": "Mausoleum of Fairies", "sectionName": "Key fairy unlock"}
locationTable["Coin: Illusion (Katana)"] = {"mapName": "gate_of_illusion", "subMapXY": [595, 1860], "locationName": "Mausoleum of Fairies", "sectionName": "Katana wall"}
locationTable["Key of Eternity"] = {"mapName": "gate_of_illusion", "subMapXY": [2240, 1850], "locationName": "Chi You's Room", "sectionName": "Chi You's item"}
locationTable["Cog of the Soul"] = {"mapName": "gate_of_illusion", "subMapXY": [2900, 340], "locationName": "Cog of Life", "sectionName": "The Key of Life"}

#Inferno Cavern
locationTable["Ice Cape"] = {"mapName": "inferno_cavern", "subMapXY": [4430, 2015], "locationName": "Treasury of Ice", "sectionName": "Ice Cape Location"}
locationTable["bunplus.com"] = {"mapName": "inferno_cavern", "subMapXY": [3345, 2020], "locationName": "Treasury of Ice", "sectionName": "Hidden in the wall (Bunplus Location)"}
locationTable["Shop 14 (Inferno)"] = {"mapName": "inferno_cavern", "subMapXY": [2680, 1540], "locationName": "Nemesistwo's shop", "sectionName": "Store Stock"}
locationTable["Flare Gun"] = {"mapName": "inferno_cavern", "subMapXY": [1355, 1775], "locationName": "Serdab of Light", "sectionName": "Block Puzzle"}
locationTable["Chain Whip"] = {"mapName": "inferno_cavern", "subMapXY": [320, 1135], "locationName": "Pylon of Power", "sectionName": "Pazuzu's item"}
locationTable["Trap: Inferno Orb"] = {"mapName": "inferno_cavern", "subMapXY": [2750, 660], "locationName": "Twin's Footstool", "sectionName": "In plain sight"}
locationTable["Coin: Inferno (Lava)"] = {"mapName": "inferno_cavern", "subMapXY": [3145, 815], "locationName": "Twin's Footstool", "sectionName": "Break the wall in lava from screen to the right"}
locationTable["Coin: Inferno (Spikes)"] = {"mapName": "inferno_cavern", "subMapXY": [1635, 170], "locationName": "Echidna's Chamber", "sectionName": "Coin chest in the wall next to ladder"}
locationTable["Map (Inferno Cavern)"] = {"mapName": "inferno_cavern", "subMapXY": [2615, 175], "locationName": "Twin's Footstool", "sectionName": "Enrage the snakes"}
locationTable["Event: Viy Defeated"] = {"mapName": "inferno_cavern", "subMapXY": [2409, 2490], "locationName": "Viy's Room", "sectionName": "Viy", "hostedItem": "Viy"}


#Mausoleum of Giants
locationTable["Coin: Mausoleum"] = {"mapName": "mausoleum_of_giants", "subMapXY": [1475, 340], "locationName": "Last Shrine", "sectionName": "Coin chest in the wall"}
locationTable["Rolling Shuriken"] = {"mapName": "mausoleum_of_giants", "subMapXY": [315, 650], "locationName": "Shrine of the Giants", "sectionName": "Ghost Lord's item"}
locationTable["Map (Mausoleum of the Giants)"] = {"mapName": "mausoleum_of_giants", "subMapXY": [1650, 575], "locationName": "Approach of the Giants", "sectionName": "Mausoleum Map location"}
locationTable["Ankh Jewel (Mausoleum of the Giants)"] = {"mapName": "mausoleum_of_giants", "subMapXY": [4390, 1130], "locationName": "Dolphin's Room", "sectionName": "Mausoleum Jewel location"}
locationTable["Shop 6 (Mausoleum)"] = {"mapName": "mausoleum_of_giants", "subMapXY": [3478, 1305], "locationName": "Greedy Charlie's shop", "sectionName": "Store Stock"}
locationTable["Sacred Orb (Mausoleum of the Giants)"] = {"mapName": "mausoleum_of_giants", "subMapXY": [3460, 1615], "locationName": "Star Palace of the Giants", "sectionName": "Strength at the foot of Futo"}
locationTable["Event: Sakit Defeated"] = {"mapName": "mausoleum_of_giants", "subMapXY": [1663, 2103], "locationName": "Sakit's Room", "sectionName": "Sakit", "hostedItem": "Sakit"}

#Temple of Moonlight
locationTable["Philosopher's Ocarina"] = {"mapName": "temple_of_moonlight", "subMapXY": [2240, 1295], "locationName": "Moon Pyramid: Burial Chamber", "sectionName": "Sleep within the woman"}
locationTable["Fruit of Eden"] = {"mapName": "temple_of_moonlight", "subMapXY": [1880, 745], "locationName": "Neptune's Feet", "sectionName": "Eden Seeking"}
locationTable["Axe"] = {"mapName": "temple_of_moonlight", "subMapXY": [715, 1210], "locationName": "Serdab of Power", "sectionName": "Rolling Rock"}
locationTable["Coin: Moonlight"] = {"mapName": "temple_of_moonlight", "subMapXY": [1040, 170], "locationName": "Stairway of Eden", "sectionName": "Attack the spiked wall"}
locationTable["Grapple Claw"] = {"mapName": "temple_of_moonlight", "subMapXY": [320, 175], "locationName": "Boneyard", "sectionName": "Grapple Claw location"}
locationTable["Map (Temple of Moonlight)"] = {"mapName": "temple_of_moonlight", "subMapXY": [1025, 735], "locationName": "Moonlight Map location", "sectionName": "Beware of spikes"}
locationTable["Serpent Staff"] = {"mapName": "temple_of_moonlight", "subMapXY": [2500, 2810], "locationName": "Underworld Palace", "sectionName": "Anubis's item"}
locationTable["Shop 11 (Moonlight)"] = {"mapName": "temple_of_moonlight", "subMapXY": [3758, 1535], "locationName": "Kingvalley II's shop", "sectionName": "Store Stock"}

#Surface
locationTable["Feather"] = {"mapName": "surface", "subMapXY": [195, 1061], "locationName": "Village Altar", "sectionName": "Village Altar"}
locationTable["Shop 1 (Surface)"] = {"mapName": "surface", "subMapXY": [4360, 1700], "locationName": "Modro's Shop", "sectionName": "Store Stock"}
locationTable["Shop 2 (Surface)"] = {"mapName": "surface", "subMapXY": [3580, 1420], "locationName": "Nebur's shop", "sectionName": "Initial Stock"}
locationTable["Shop 2 Alt (Surface)"] = {"mapName": "surface", "subMapXY": [3580, 1420], "locationName": "Nebur's shop", "sectionName": "4 Guardian Item", "isChild": True, "childOf": "Shop 2 (Surface)"}
locationTable["xmailer.exe"] = {"mapName": "surface", "subMapXY": [4041, 1420], "locationName": "Xelpud", "sectionName": "First item (xmailer item)"}
locationTable["Mulana Talisman"] = {"mapName": "surface", "subMapXY": [4041, 1420], "locationName": "Xelpud", "sectionName": "Diary turn in", "isChild": True, "childOf": "Mulana Talisman"}
locationTable["Shop 3 (Surface)"] = {"mapName": "surface", "subMapXY": [4100, 1780], "locationName": "Sidro's Shop", "sectionName": "Store Stock"}
locationTable["deathv.exe"] = {"mapName": "surface", "subMapXY": [5385, 1296], "locationName": "Behind Xelpud Statue", "sectionName": "Behind Xelpud Statue"}
locationTable["Map (Surface)"] = {"mapName": "surface", "subMapXY": [5437, 1070], "locationName": "Scan Skeleton", "sectionName": "Scan Skeleton (Surface Map location)"}
locationTable["Shell Horn"] = {"mapName": "surface", "subMapXY": [5250, 730], "locationName": "Sound Canyon", "sectionName": "Shell Horn Location"}
locationTable["Coin: Surface (Waterfall)"] = {"mapName": "surface", "subMapXY": [6530, 415], "locationName": "Bahrun's Waterfall", "sectionName": "Coin Chest Above Waterfall"}
locationTable["mekuri.exe"] = {"mapName": "surface", "subMapXY": [6760, 820], "locationName": "Bahrun's Waterfall", "sectionName": "Nigoro Maniac (Mekuri Location)"}
locationTable["Birth Seal"] = {"mapName": "surface", "subMapXY": [7580, 735], "locationName": "Bahrun's Waterfall", "sectionName": "High chest behind the right Waterfall"}
locationTable["Sacred Orb (Surface)"] = {"mapName": "surface", "subMapXY": [7510, 1175], "locationName": "Waterfall of the Goddess", "sectionName": "Low chest behind the right Waterfall"}
locationTable["Coin: Surface (Ruin Path)"] = {"mapName": "surface", "subMapXY": [6300, 730], "locationName": "Gazing Hill", "sectionName": "Coin Chest in Bomb Wall"}
locationTable["Coin: Surface (Seal)"] = {"mapName": "surface", "subMapXY": [2469, 1380], "locationName": "Cliff in front of the Altar", "sectionName": "Coin Chest above Hot Spring"}

#Tower of Ruin
locationTable["Map (Tower of Ruin)"] = {"mapName": "tower_of_ruin", "subMapXY": [915, 1210], "locationName": "Approach of the Philosophers", "sectionName": "Top corridor from Eden"}
locationTable["Shop 15 (Ruin)"] = {"mapName": "tower_of_ruin", "subMapXY": [1600, 1060], "locationName": "Efspi's shop", "sectionName": "Store Stock"}
locationTable["Earth Spear"] = {"mapName": "tower_of_ruin", "subMapXY": [2620, 2015], "locationName": "Fountain of Heat", "sectionName": "Earth Spear location"}
locationTable["Ankh Jewel (Tower of Ruin)"] = {"mapName": "tower_of_ruin", "subMapXY": [3520, 1770], "locationName": "Monument of Name", "sectionName": "Name the nameless one (mid left, top right)"}
locationTable["Sacred Orb (Tower of Ruin)"] = {"mapName": "tower_of_ruin", "subMapXY": [4185, 2095], "locationName": "Fountain of Heat", "sectionName": "Dais behind the Crusher (Ruins Orb location)"}
locationTable["Coin: Ruin"] = {"mapName": "tower_of_ruin", "subMapXY": [2600, 820], "locationName": "Approach of Life", "sectionName": "Subweapon only wall breaking"}
locationTable["Djed Pillar"] = {"mapName": "tower_of_ruin", "subMapXY": [3115, 415], "locationName": "Nuwa's Pyramid", "sectionName": "Nuwa's item"}

#Shrine of the Mother
locationTable["bounce.exe"] = {"mapName": "shrine_of_the_mother", "subMapXY": [2940, 1535], "locationName": "Palenque's Room", "sectionName": "Subweapon only Totem"}
locationTable["Coin: Shrine"] = {"mapName": "shrine_of_the_mother", "subMapXY": [675, 2250], "locationName": "Viy's Room", "sectionName": "Katana only Totem"}
locationTable["Diary"] = {"mapName": "shrine_of_the_mother", "subMapXY": [3150, 590], "locationName": "Ellmac's Room", "sectionName": "Show Talisman to Xelpud"}
locationTable["Crystal Skull"] = {"mapName": "shrine_of_the_mother", "subMapXY": [720, 820], "locationName": "Sakit's Room", "sectionName": "Crystal Skull location"}
locationTable["Sacred Orb (Shrine of the Mother)"] = {"mapName": "shrine_of_the_mother", "subMapXY": [1600, 905], "locationName": "Sakit's Room", "sectionName": "Four Seals (Shrine Orb location)"}
locationTable["Death Seal"] = {"mapName": "shrine_of_the_mother", "subMapXY": [3410, 1385], "locationName": "Treasury", "sectionName": "Philosopher's ladder from Endless Corridor"}
locationTable["Map (Shrine of the Mother)"] = {"mapName": "shrine_of_the_mother", "subMapXY": [585, 1220], "locationName": "Treasury", "sectionName": "Shrine Map location (Up from Twin Labyrinth)"}

#Spring in the Sky
locationTable["Sacred Orb (Spring in the Sky)"] = {"mapName": "spring_in_the_sky", "subMapXY": [318, 1540], "locationName": "Mural of Oannes", "sectionName": "Birth Seal to spawn the ladder"}
locationTable["Caltrops"] = {"mapName": "spring_in_the_sky", "subMapXY": [960, 2500], "locationName": "Goddess's Water Jug", "sectionName": "Sinking floor (Caltrop location)"}
locationTable["Coin: Spring"] = {"mapName": "spring_in_the_sky", "subMapXY": [800, 3930], "locationName": "Anunnaki's Stone Basin", "sectionName": "Through the fake wall from the right"}
locationTable["Ankh Jewel (Spring in the Sky)"] = {"mapName": "spring_in_the_sky", "subMapXY": [1840, 3450], "locationName": "Oannes's Waterfall", "sectionName": "Attack Gyonin"}
locationTable["Map (Spring in the Sky)"] = {"mapName": "spring_in_the_sky", "subMapXY": [1745, 2655], "locationName": "Goddess's Water Jug", "sectionName": "Spring Map location"}
locationTable["Glove"] = {"mapName": "spring_in_the_sky", "subMapXY": [1440, 2015], "locationName": "Sacred Lake", "sectionName": "Open the floodgate"}
locationTable["Shop 12 (Spring)"] = {"mapName": "spring_in_the_sky", "subMapXY": [2517, 1620], "locationName": "Gyonin's Shop", "sectionName": "Store Stock"}
locationTable["Shop 12 Alt (Spring)"] = {"mapName": "spring_in_the_sky", "subMapXY": [2120, 1520], "locationName": "Gyonin's Shop", "sectionName": "Secret Stock"}
locationTable["Scalesphere"] = {"mapName": "spring_in_the_sky", "subMapXY": [1975, 180], "locationName": "Waterfall Approach", "sectionName": "Scalesphere location"}
locationTable["Origin Seal"] = {"mapName": "spring_in_the_sky", "subMapXY": [2620, 660], "locationName": "Room of Origin", "sectionName": "Nuckelavee's item"}
locationTable["Event: Bahamut Defeated"] = {"mapName": "spring_in_the_sky", "subMapXY": [1676, 862], "locationName": "Bahamut's Room", "sectionName": "Bahamut", "hostedItem": "Bahamut"}

#Temple of the Sun
locationTable["Isis' Pendant"] = {"mapName": "temple_of_sun", "subMapXY": [325, 260], "locationName": "Isis's room", "sectionName": "Read the tablet for the dias"}
locationTable["Map (Temple of the Sun)"] = {"mapName": "temple_of_sun", "subMapXY": [1860, 335], "locationName": "Watchtower", "sectionName": "Disappearing ladder"}
locationTable["Knife"] = {"mapName": "temple_of_sun", "subMapXY": [2180, 655], "locationName": "Altar of War", "sectionName": "Aim and Shoot"}
locationTable["Shop 8 (Sun)"] = {"mapName": "temple_of_sun", "subMapXY": [2180, 815], "locationName": "Shalom III's shop", "sectionName": "Store Stock"}
locationTable["Book of the Dead"] = {"mapName": "temple_of_sun", "subMapXY": [1759, 1215], "locationName": "Mulbruk", "sectionName": "Item after visiting Anubis"}
locationTable["Coin: Sun (Pyramid)"] = {"mapName": "temple_of_sun", "subMapXY": [2830, 1500], "locationName": "Sun Pyramid: Burial Chamber", "sectionName": "Chest in bombable wall"}
locationTable["Sacred Orb (Temple of the Sun)"] = {"mapName": "temple_of_sun", "subMapXY": [2320, 1775], "locationName": "Great Colonnade: Left-side room", "sectionName": "Kill the bats"}
locationTable["Shop 10 (Sun)"] = {"mapName": "temple_of_sun", "subMapXY": [1080, 2100], "locationName": "Kingvalley I's shop", "sectionName": "Store Stock"}
locationTable["Shop 9 (Sun)"] = {"mapName": "temple_of_sun", "subMapXY": [2758, 2335], "locationName": "Usas VI's shop", "sectionName": "Store Stock"}
locationTable["Ankh Jewel (Temple of the Sun)"] = {"mapName": "temple_of_sun", "subMapXY": [685, 2040], "locationName": "Horus' Room of Pillars", "sectionName": "Meditate under Wedjet"}
locationTable["Talisman"] = {"mapName": "temple_of_sun", "subMapXY": [3705, 1290], "locationName": "Great Colonnade: Right-side room", "sectionName": "Viy's item"}
locationTable["Bronze Mirror"] = {"mapName": "temple_of_sun", "subMapXY": [4200, 1645], "locationName": "Altar of Mirrors", "sectionName": "Bronze Mirror location"}
locationTable["Event: Ellmac Defeated"] = {"mapName": "temple_of_sun", "subMapXY": [2298, 2734], "locationName": "Ellmac's Room", "sectionName": "Ellmac", "hostedItem": "Ellmac"}

#Twin Labyrinths
locationTable["Shop 19 (Big Bro)"] = {"mapName": "twin_labyrinths", "subMapXY": [6078, 1535], "locationName": "Big Brother's shop", "sectionName": "Store Stock"}
locationTable["Shop 18 (Lil Bro)"] = {"mapName": "twin_labyrinths", "subMapXY": [318, 1535], "locationName": "Little Brother's shop", "sectionName": "Store Stock"}
locationTable["Trap: Twin Ankh"] = {"mapName": "twin_labyrinths", "subMapXY": [6355, 655], "locationName": "Twin's Surrounding Wall", "sectionName": "Plain Sight"}
locationTable["Sacred Orb (Twin Labyrinths)"] = {"mapName": "twin_labyrinths", "subMapXY": [1450, 1325], "locationName": "Demon Altar", "sectionName": "Hidden dais above the passage"}
locationTable["Shop 21 (Unsolvable)"] = {"mapName": "twin_labyrinths", "subMapXY": [2498, 1535], "locationName": "Metagear's shop", "sectionName": "Store Stock"}
locationTable["Shop 20 (Twin Labs)"] = {"mapName": "twin_labyrinths", "subMapXY": [3900, 1535], "locationName": "Sturdy Snake's shop", "sectionName": "Store Stock"}
locationTable["Map (Twin Labyrinths)"] = {"mapName": "twin_labyrinths", "subMapXY": [2470, 655], "locationName": "Zodiac", "sectionName": "Twin Map location (Break the wall right to ladder)"}
locationTable["Ankh Jewel (Twin Labyrinths)"] = {"mapName": "twin_labyrinths", "subMapXY": [4103, 580], "locationName": "Zodiac", "sectionName": "Twin Jewel location (Confer light upon the twins)"}
locationTable["Katana"] = {"mapName": "twin_labyrinths", "subMapXY": [5440, 575], "locationName": "Zodiac", "sectionName": "Katana location"}
locationTable["Ring"] = {"mapName": "twin_labyrinths", "subMapXY": [960, 575], "locationName": "Zodiac", "sectionName": "Ring location"}
locationTable["Coin: Twin (Lower)"] = {"mapName": "twin_labyrinths", "subMapXY": [890, 1690], "locationName": "Zu's Room", "sectionName": "Coin Chest in the wall"}
locationTable["Coin: Twin (Witches)"] = {"mapName": "twin_labyrinths", "subMapXY": [4820, 1135], "locationName": "Demon Altar", "sectionName": "Hidden breakable wall above the passage"}
locationTable["Coin: Twin (Escape)"] = {"mapName": "twin_labyrinths", "subMapXY": [1220, 650], "locationName": "Zodiac", "sectionName": "Coin Chest (Escape)"}
locationTable["Event: Baphomet Defeated"] = {"mapName": "twin_labyrinths", "subMapXY": [2244, 1053], "locationName": "Baphomet's Room", "sectionName": "Baphomet", "hostedItem": "Baphomet"}

#Gate of Time
locationTable["lamulana.exe"] = {"mapName": "gate_of_time", "subMapXY": [950, 270], "locationName": "Retro Surface", "sectionName": "In the Ladder Wall"}

#Hell Temple
locationTable["Shop 23 (HT)"] = {"mapName": "hell_temple", "subMapXY": [1836, 2000], "locationName": "Hell Temple", "sectionName": "Draucet's Shop"}
locationTable["Provocative Bathing Suit"] = {"mapName": "hell_temple", "subMapXY": [1600, 5060], "locationName": "Hell Temple", "sectionName": "Draucet's Gift"}

#NPC Doors, sharing same cooridnate as shops if applicable
locationTable["NPCL: Modro"] = {"mapName": "surface", "subMapXY": [4360, 1700], "locationName": "Modro's Shop", "sectionName": "NPC door"}
locationTable["NPCL: Nebur"] = {"mapName": "surface", "subMapXY": [3580, 1620], "locationName": "Nebur's shop", "sectionName": "NPC door"}
locationTable["NPCL: Sidro"] = {"mapName": "surface", "subMapXY": [4100, 1780], "locationName": "Sidro's Shop", "sectionName": "NPC door"}
locationTable["NPCL: Elder Xelpud "] = {"mapName": "surface", "subMapXY": [4040, 1620], "locationName": "Xelpud's Tent", "sectionName": "NPC door"}
locationTable["NPCL: Hiner"] = {"mapName": "surface", "subMapXY": [1800, 1140], "locationName": "Hiner's Tent", "sectionName": "NPC door"}
locationTable["NPCL: Moger"] = {"mapName": "surface", "subMapXY": [3440, 1780], "locationName": "Moger's Tent", "sectionName": "NPC door"}
locationTable["NPCL: Former Mekuri Master"] = {"mapName": "surface", "subMapXY": [6760, 820], "locationName": "Mekuri Master's Tent", "sectionName": "NPC door"}

locationTable["NPCL: Priest Zarnac"] = {"mapName": "gate_of_guidance", "subMapXY": [700, 1545], "locationName": "Priest Zarnac", "sectionName": "NPC door"}
locationTable["NPCL: Penadvent of ghost"] = {"mapName": "gate_of_guidance", "subMapXY": [858, 2662], "locationName": "Penadvent of ghost shop", "sectionName": "NPC door"}

locationTable["NPCL: Priest Xanado"] = {"mapName": "mausoleum_of_giants", "subMapXY": [1980, 105], "locationName": "Priest Xanado", "sectionName": "NPC door"}
locationTable["NPCL: Greedy Charlie"] = {"mapName": "mausoleum_of_giants", "subMapXY": [3478, 1305], "locationName": "Greedy Charlie's shop", "sectionName": "NPC door"}

locationTable["NPCL: Shalom III"] = {"mapName": "temple_of_sun", "subMapXY": [2180, 815], "locationName": "Shalom III's shop", "sectionName": "NPC door"}
locationTable["NPCL: Kingvalley I"] = {"mapName": "temple_of_sun", "subMapXY": [1080, 2100], "locationName": "Kingvalley I's shop", "sectionName": "NPC door"}
locationTable["NPCL: Usas VI"] = {"mapName": "temple_of_sun", "subMapXY": [2758, 2335], "locationName": "Usas VI's shop", "sectionName": "NPC door"}
locationTable["NPCL: Priest Madomono"] = {"mapName": "temple_of_sun", "subMapXY": [3700, 1055], "locationName": "Priest Madomono", "sectionName": "NPC door"}

locationTable["NPCL: Mr. Fishman (Original)"] = {"mapName": "spring_in_the_sky", "subMapXY": [2517, 1620], "locationName": "Gyonin's Shop", "sectionName": "NPC door"}
locationTable["NPCL: Mr. Fishman (Alt)"] = {"mapName": "spring_in_the_sky", "subMapXY": [2120, 1520], "locationName": "Gyonin's Shop", "sectionName": "Secret NPC door"}
locationTable["NPCL: Philosopher Giltoriyo"] = {"mapName": "spring_in_the_sky", "subMapXY": [60, 2265], "locationName": "Philosopher Giltoriyo", "sectionName": "NPC door"}
locationTable["NPCL: Priest Hidlyda"] = {"mapName": "spring_in_the_sky", "subMapXY": [960, 3545], "locationName": "Priest Hidlyda", "sectionName": "NPC door"}

locationTable["NPCL: Hot-blooded Nemesistwo"] = {"mapName": "inferno_cavern", "subMapXY": [2680, 1540], "locationName": "Nemesistwo's shop", "sectionName": "NPC door"}
locationTable["NPCL: Priest Gailious"] = {"mapName": "inferno_cavern", "subMapXY": [2342, 1220], "locationName": "Priest Gailious", "sectionName": "NPC door"}
locationTable["NPCL: Priest Romancis"] = {"mapName": "inferno_cavern", "subMapXY": [1480, 1380], "locationName": "Priest Romancis", "sectionName": "NPC door"}

locationTable["NPCL: Operator Combaker"] = {"mapName": "chamber_of_extinction", "subMapXY": [4776, 740], "locationName": "Combaker's shop", "sectionName": "NPC door"}
locationTable["NPCL: Priest Triton"] = {"mapName": "chamber_of_extinction", "subMapXY": [5180, 1060], "locationName": "Priest Triton", "sectionName": "NPC door"}
locationTable["NPCL: Priest Aramo"] = {"mapName": "chamber_of_extinction", "subMapXY": [3340, 1540], "locationName": "Priest Aramo", "sectionName": "NPC door"}

locationTable["NPCL: Yiear Kungfu"] = {"mapName": "twin_labyrinths", "subMapXY": [6078, 1535], "locationName": "Big Brother's shop", "sectionName": "NPC door"}
locationTable["NPCL: Yiegah Kungfu"] = {"mapName": "twin_labyrinths", "subMapXY": [318, 1535], "locationName": "Little Brother's shop", "sectionName": "NPC door"}
locationTable["NPCL: Arrogant Metagear"] = {"mapName": "twin_labyrinths", "subMapXY": [2498, 1535], "locationName": "Metagear's shop", "sectionName": "NPC door"}
locationTable["NPCL: Arrogant Sturdy Snake"] = {"mapName": "twin_labyrinths", "subMapXY": [3900, 1535], "locationName": "Sturdy Snake's shop", "sectionName": "NPC door"}
locationTable["NPCL: Priest Jaguarfiv"] = {"mapName": "twin_labyrinths", "subMapXY": [5438, 340], "locationName": "Priest Jaguarfiv", "sectionName": "NPC door"}

locationTable["NPCL: Affected Knimare"] = {"mapName": "endless_corridor", "subMapXY": [1500, 340], "locationName": "Knimare's shop", "sectionName": "NPC door"}
locationTable["NPCL: The Fairy Queen"] = {"mapName": "endless_corridor", "subMapXY": [58, 180], "locationName": "The Fairy Queen", "sectionName": "NPC door"}

locationTable["NPCL: Mover Athleland"] = {"mapName": "gate_of_illusion", "subMapXY": [580, 1225], "locationName": "Mover Athleland's shop", "sectionName": "NPC door"}
locationTable["NPCL: duplex"] = {"mapName": "gate_of_illusion", "subMapXY": [2302, 1545], "locationName": "Dev duplex", "sectionName": "NPC door"}
locationTable["NPCL: Mr. Slushfund"] = {"mapName": "gate_of_illusion", "subMapXY": [3258, 1545], "locationName": "Mr. Slushfund", "sectionName": "NPC door"}
locationTable["NPCL: Priest Alest"] = {"mapName": "gate_of_illusion", "subMapXY": [3700, 2025], "locationName": "Priest Alest", "sectionName": "NPC door"}

locationTable["NPCL: Giant Mopiran"] = {"mapName": "graveyard_of_giants", "subMapXY": [120, 420], "locationName": "Giant Mopiran's shop", "sectionName": "NPC door"}
locationTable["NPCL: Giant Thexde"] = {"mapName": "graveyard_of_giants", "subMapXY": [2682, 1540], "locationName": "Giant Thexde", "sectionName": "NPC door"}

locationTable["NPCL: Kingvalley II"] = {"mapName": "temple_of_moonlight", "subMapXY": [3758, 1535], "locationName": "Kingvalley II's shop", "sectionName": "NPC door"}
locationTable["NPCL: Samieru"] = {"mapName": "temple_of_moonlight", "subMapXY": [698, 1295], "locationName": "Dev Samieru", "sectionName": "NPC door"}
locationTable["NPCL: Philosopher Alsedana"] = {"mapName": "temple_of_moonlight", "subMapXY": [2760, 1055], "locationName": "Philosopher Alsedana", "sectionName": "NPC door"}

locationTable["NPCL: Energetic Belmont"] = {"mapName": "tower_of_the_goddess", "subMapXY": [378, 1380], "locationName": "Energetic Belmont's shop", "sectionName": "NPC door"}
locationTable["NPCL: Naramura"] = {"mapName": "tower_of_the_goddess", "subMapXY": [2485, 2280], "locationName": "Dev Naramura", "sectionName": "NPC door"}
locationTable["NPCL: Philosopher Samaranta"] = {"mapName": "tower_of_the_goddess", "subMapXY": [1840, 2100], "locationName": "Philosopher Samaranta", "sectionName": "NPC door"}

locationTable["NPCL: Mechanical Efspi"] = {"mapName": "tower_of_ruin", "subMapXY": [1600, 1060], "locationName": "Efspi's shop", "sectionName": "NPC door"}
locationTable["NPCL: Priest Laydoc"] = {"mapName": "tower_of_ruin", "subMapXY": [3260, 2020], "locationName": "Priest Laydoc", "sectionName": "NPC door"}

locationTable["NPCL: Mud Man Qubert"] = {"mapName": "chamber_of_birth", "subMapXY": [1357, 1780], "locationName": "Mud Man Qubert's shop", "sectionName": "NPC door"}
locationTable["NPCL: Priest Ashgine"] = {"mapName": "chamber_of_birth", "subMapXY": [700, 1700], "locationName": "Priest Ashgine", "sectionName": "NPC door"}

locationTable["NPCL: Philosopher Fobos"] = {"mapName": "dimensional_corridor", "subMapXY": [320, 2100], "locationName": "Philosopher Fobos", "sectionName": "NPC door"}
locationTable["NPCL: 8bit Elder"] = {"mapName": "gate_of_time", "subMapXY": [200, 180], "locationName": "8bit Elder", "sectionName": "NPC door"}
locationTable["NPCL: Tailor Dracuet"] = {"mapName": "hell_temple", "subMapXY": [1836, 2000], "locationName": "Draucet's Shop", "sectionName": "NPC door"}

locationTranslation = {}
locationTranslation["surface"] = [0, 636, 0.11380208333]
locationTranslation["gate_of_guidance"] = [0, 0, 0.09754464285]
locationTranslation["gate_of_illusion"] = [437, 0, 0.09754464285]
locationTranslation["mausoleum_of_giants"] = [874, 17, 0.0853515625]
locationTranslation["graveyard_of_giants"] = [1311, 0, 0.09754464285]
locationTranslation["temple_of_sun"] = [0, 304, 0.09754464285]
locationTranslation["temple_of_moonlight"] = [437, 282, 0.11380208333]
locationTranslation["spring_in_the_sky"] = [3088, 0, 0.0978125]
locationTranslation["tower_of_the_goddess"] = [3468, 0, 0.1084375]
locationTranslation["chamber_of_extinction"] = [1748, 0, 0.11701388888]
locationTranslation["chamber_of_birth"] = [1757, 281, 0.11371527777]
locationTranslation["inferno_cavern"] = [873, 304, 0.09754464285]
locationTranslation["tower_of_ruin"] = [1311, 304, 0.09754464285]
locationTranslation["endless_corridor"] = [2422, 0, 0.195]
locationTranslation["dimensional_corridor"] = [2555, 468, 0.139453125]
locationTranslation["twin_labyrinths"] = [933, 609, 0.1365625]
locationTranslation["shrine_of_the_mother"] = [1866, 608, 0.11380208333]
locationTranslation["gate_of_time"] = [3046, 468, 0.08883928571]
locationTranslation["hell_temple"] = [3499, 468, 0.0890625]

def returnJavaMethods(someTree, someClassName, someListOfMethods):
	listOfFoundMethods = []
	for path, node in someTree.filter(javalang.tree.ClassDeclaration):
		if node.name == someClassName:
			for path2, node2 in node.filter(javalang.tree.MethodDeclaration):
				if node2.name in someListOfMethods:
					listOfFoundMethods.append(node2)
	return listOfFoundMethods
	
def buildVanillaRules():
	vanillaRules = []
	backsideDoorMethods = returnJavaMethods(javalang.parse.parse(requests.get("https://raw.githubusercontent.com/thezerothcat/LaMulanaRandomizer/master/src/main/java/lmr/randomizer/randomization/BacksideDoorRandomizer.java").text), "BacksideDoorRandomizer", ["getDoorLocation", "getDoorToLocation", "getBoss"])
	transitionGateMethods = returnJavaMethods(javalang.parse.parse(requests.get("https://raw.githubusercontent.com/thezerothcat/LaMulanaRandomizer/master/src/main/java/lmr/randomizer/randomization/TransitionGateRandomizer.java").text), "TransitionGateRandomizer", ["determineGateDestinations", "randomizeVerticalTransitions", "getGatesFromLocation", "randomizeVerticalTransitions"])

	bossNodes = {}

	for someNodeEntry in backsideDoorMethods:
		if someNodeEntry.name == "getBoss":
			for pathEntry, nodeEntry in someNodeEntry.filter(javalang.tree.IfStatement):
				if (nodeEntry.condition.operandr.value != "null"):
					bossNodes[nodeEntry.condition.operandr.value] = nodeEntry.then_statement.statements[0].expression.value.replace("\"", "")

	for someNodeEntry in backsideDoorMethods:
		if someNodeEntry.name == "getDoorLocation" or someNodeEntry.name == "getDoorToLocation":
			for pathEntry, nodeEntry in someNodeEntry.filter(javalang.tree.IfStatement):
				toAppend = nodeEntry.then_statement.statements[0].expression.value
				if "Door: " in nodeEntry.condition.value and "Endless Corridor [1F]" not in toAppend:
					doorNumber = nodeEntry.condition.value.replace("Door: ", "").replace("B", "").replace("F", "").replace("\"", "")
					if doorNumber in bossNodes:
						toAppend = toAppend + ", " + bossNodes[doorNumber] + ", Bronze Mirror"
					elif doorNumber == "9":
						toAppend = toAppend.replace("Location:", "Fairy:")
					vanillaRules.append([nodeEntry.condition.value, toAppend])
				vanillaRules.append([nodeEntry.condition.value.replace("Door: ", "Exit: Door "), toAppend.replace("Location: ", "Exit: ")])

	for someNodeEntry in transitionGateMethods:
		if someNodeEntry.name == "determineGateDestinations" or someNodeEntry == "randomizeVerticalTransitions":
			for pathEntry, nodeEntry in someNodeEntry.filter(javalang.tree.IfStatement):
				for somePath, someInvocation in nodeEntry.filter(javalang.tree.MethodInvocation):
					if someInvocation.qualifier == "transitionGateDestinationMap" and len(someInvocation.arguments) == 2:
						vanillaRules.append([someInvocation.arguments[0].value, someInvocation.arguments[1].value])
						vanillaRules.append([someInvocation.arguments[0].value.replace("Transition:", "Exit:"), someInvocation.arguments[1].value.replace("Transition:", "Exit:")])
		elif someNodeEntry.name == "getGatesFromLocation":
			for pathEntry, nodeEntry in someNodeEntry.filter(javalang.tree.IfStatement):
				for someReturnPath, someReturnValueList in nodeEntry.then_statement.filter(javalang.tree.ReturnStatement):
					for someReturnValue in someReturnValueList.expression.arguments:
						vanillaRules.append([someReturnValue.value.replace("Transition:", "Exit:"), nodeEntry.condition.value.replace("Location:", "Exit:")])
		elif someNodeEntry.name == "randomizeVerticalTransitions":
			for pathEntry, nodeEntry in someNodeEntry.filter(javalang.tree.IfStatement):
				for someMethodPath, someMethodEntry in nodeEntry.else_statement.filter(javalang.tree.MethodInvocation):
					if someMethodEntry.qualifier == "transitionGateDestinationMap":
						vanillaRules.append([someMethodEntry.arguments[0].value.replace("Transition:", "Exit:"), someMethodEntry.arguments[1].value.replace("Transition:", "Exit:")])
	toReturn = []
	for someVanillaRule in vanillaRules:
		toReturn.append((" => ".join(someVanillaRule).replace("\"", "") + ", Setting: Nonrandom Transitions"))
	return toReturn

def parseLogic(someRuleList, masterList):
	for itemEntry in someRuleList:
		itemEntry = re.sub("#.*", "", itemEntry)
		if len(itemEntry) > 1:
			firstSplit = itemEntry.split("=>")
			requirements = []
			for requirement in firstSplit[1].split(","):
				requirements.append(requirement.strip())
			if not masterList.get(firstSplit[0].strip()):
				masterList[firstSplit[0].strip()] = []
			masterList[firstSplit[0].strip()].append(requirements)
	return masterList


def buildMasterList():
	listOfFiles = ["location_reqs.txt", "item_reqs.txt", "event_reqs.txt", "shop_reqs.txt", "attack_reqs.txt", "dead_ends.txt", "transition_reqs.txt", "glitch_reqs.txt", "coin_chest_reqs.txt", "trap_item_reqs.txt", "bosses/medium_reqs.txt","npc_door_reqs.txt"]
	masterList = {}
	for someFile in listOfFiles:
		someDownloadedFile = requests.get("https://raw.githubusercontent.com/thezerothcat/LaMulanaRandomizer/master/src/main/resources/lmr/randomizer/requirement/" + someFile).text.splitlines()
		masterList = parseLogic(someDownloadedFile, masterList)
	localFiles = ["seal_logic.txt","npc_logic.txt","other_logic.txt"]
	for someFile in localFiles:
		f=open("./logic/"+someFile, "r")
		someDownloadedFile = f.read().splitlines()
		masterList = parseLogic(someDownloadedFile, masterList)
		f.close()
	masterList = parseLogic(buildVanillaRules(), masterList)
	return masterList

listOfItems = []
listofNodes=[]
listOfGuardians=["Amphisbaena", "Sakit", "Ellmac", "Bahamut", "Viy", "Palenque", "Baphomet", "Tiamat"]
listofInitialChecks=["startingAreaLocationIsSurfaceStd","startingAreaLocationIsIllusionStd","startingAreaLocationIsGuidanceStd","startingAreaLocationIsMausoleumStd","startingAreaLocationIsInfernoStd","startingAreaLocationIsTwinFStd","startingAreaLocationIsEndlessStd","startingAreaLocationIsTwinBStd"]
NodesNotifyChart={}

def luaWriter(someSimpleRequirementList, filePoint):
	luaString = ""
	for someKey, listOfRequirements in someSimpleRequirementList.items():
		if ":" not in someKey: #to Distinguish item to get and item location on the map
			someKey = "Vanilla"+someKey
		sanitizedKey = common.sanitize(someKey)
		if someKey not in listofNodes:
			luaString = luaString+ "NodeStatusArray[\""+sanitizedKey+"\"]=false\n"
			luaString = luaString+ "NodeStatusArray[\""+sanitizedKey+"MinReqs\"]=false\n"
			listofNodes.append(someKey)
			NodesNotifyChart[someKey]=[]
			NodesNotifyChart[someKey + "MinReqs"]=[]
		for someRequirement in listOfRequirements:
			for someSomeRequirement in someRequirement:
				sanitizedRequirement = common.sanitize(someSomeRequirement)
				if "!" in someSomeRequirement or someSomeRequirement == "StatePreEscape":
						luaString = luaString+ "NodeStatusArray[\""+sanitizedRequirement+"\"]=true\n"
						luaString = luaString+ "NodeStatusArray[\""+sanitizedRequirement+"MinReqs\"]=true\n"
						listofNodes.append(someSomeRequirement)
						NodesNotifyChart[someSomeRequirement]=[]
						NodesNotifyChart[someSomeRequirement + "MinReqs"]=[]
				elif ":" in someSomeRequirement and "Defeated" in someSomeRequirement:
					done=0
					for Guardian in listOfGuardians: #Hack to put Guardians on item Grid
						if Guardian in someSomeRequirement and "Children" not in someSomeRequirement:#Distinsuish Tiamat and her Children
							done=1
							if someSomeRequirement not in listofNodes: 
								luaString = luaString+ "NodeStatusArray[\""+Guardian+"\"]=false\n"
								luaString = luaString+ "NodeStatusArray[\""+Guardian+"MinReqs\"]=false\n"
								listofNodes.append(someSomeRequirement)
								NodesNotifyChart[Guardian]=[]
								NodesNotifyChart[Guardian + "MinReqs"]=[]
								listofInitialChecks.append(Guardian)
					if not done:
						if someSomeRequirement not in listofNodes: 
							luaString = luaString+ "NodeStatusArray[\""+sanitizedRequirement+"\"]=false\n"
							luaString = luaString+ "NodeStatusArray[\""+sanitizedRequirement+"MinReqs\"]=false\n"
							listofNodes.append(someSomeRequirement)
							NodesNotifyChart[someSomeRequirement]=[]
							NodesNotifyChart[someSomeRequirement + "MinReqs"]=[]
				elif ":" in someSomeRequirement and "Setting" not in someSomeRequirement and "Boost" not in someSomeRequirement and "NPCI" not in someSomeRequirement:#Boost, Settings,NPCI are in the item Grid
					if someSomeRequirement not in listofNodes:
						luaString = luaString+ "NodeStatusArray[\""+sanitizedRequirement+"\"]=false\n"
						luaString = luaString+ "NodeStatusArray[\""+sanitizedRequirement+"MinReqs\"]=false\n"
						listofNodes.append(someSomeRequirement)
						NodesNotifyChart[someSomeRequirement]=[]
						NodesNotifyChart[someSomeRequirement + "MinReqs"]=[]
				else:	#These are the items on the item grids
					if someSomeRequirement not in listofNodes:
						luaString = luaString+ "NodeStatusArray[\""+sanitizedRequirement+"\"]=false\n"
						luaString = luaString+ "NodeStatusArray[\""+sanitizedRequirement+"MinReqs\"]=false\n"
						listofNodes.append(someSomeRequirement)
						NodesNotifyChart[someSomeRequirement]=[]
						NodesNotifyChart[someSomeRequirement + "MinReqs"]=[]
						listofInitialChecks.append(someSomeRequirement)
	for Guardian in listOfGuardians:
		luaString = luaString + "NodeStatusArray[\"Event" + Guardian + "Defeated\"] = false\n"
		luaString = luaString + "NodeStatusArray[\"Event" + Guardian + "DefeatedMinReqs\"] = false\n"
	for node in listofNodes:
		if "Transition:" in node and "W1" not in node: #Make Exit: (some transition) checks for Transition: (some transition) except for one-ways(Warp)
			if ("Exit: "+node[12:]) in listofNodes:
				if ("Exit: "+node[12:]) not in someSimpleRequirementList:
					someSimpleRequirementList["Exit: "+node[12:]]=[]
				someSimpleRequirementList["Exit: "+node[12:]].append([node])
				NodesNotifyChart[node].append("Exit: "+node[12:])
		if "Door:" in node and "B8" not in node: #Same for door, other than the one way (B8)
			if ("Exit: Door "+node[6:]) in listofNodes:
				if ("Exit: Door "+node[6:]) not in someSimpleRequirementList:
					someSimpleRequirementList["Exit: Door "+node[6:]]=[]
				someSimpleRequirementList["Exit: Door "+node[6:]].append([node])
				NodesNotifyChart[node].append("Exit: Door "+node[6:])
	luaString = luaString + "InitialChecks = {}\n"
	for Items in listofInitialChecks:
		sanitizedItems = common.sanitize(Items)
		luaString = luaString + "InitialChecks[\"" + sanitizedItems + "\"]=true\n"
		luaString = luaString + "InitialChecks[\"" + sanitizedItems + "MinReqs\"]=true\n"
	#luaString = luaString + "InitialChecks[\"LocationSurfaceMain\"]=true\n" #todo: random starting position
	#luaString = luaString + "InitialChecks[\"LocationSurfaceMainMinReqs\"]=true\n"
	#luaString = luaString + "InitialChecks[\"ExitSurfaceMain\"]=true\n"
	#luaString = luaString + "InitialChecks[\"ExitSurfaceMainMinReqs\"]=true\n"
	for OrbCount in range(1,11):
		luaString = luaString + "InitialChecks[\"SacredOrb"+str(OrbCount)+"\"]=true\n"
		luaString = luaString + "InitialChecks[\"SacredOrb"+str(OrbCount)+"MinReqs\"]=true\n"
	for someKey, listOfRequirements in someSimpleRequirementList.items():	
		if ":" not in someKey:
			someKey = "Vanilla"+someKey
		for someRequirement in listOfRequirements:
			for someSomeRequirement in someRequirement:
				if ":" in someSomeRequirement and "Defeated" in someSomeRequirement:
					done=0
					for Guardian in listOfGuardians:
						if Guardian in someSomeRequirement and "Children" not in someSomeRequirement:
							done=1
							if someKey not in NodesNotifyChart[Guardian]:
								NodesNotifyChart[Guardian].append(someKey)
								NodesNotifyChart[Guardian + "MinReqs"].append(someKey + "MinReqs")
					if not done:
						if someKey not in NodesNotifyChart[someSomeRequirement]:
							NodesNotifyChart[someSomeRequirement].append(someKey)
							NodesNotifyChart[someSomeRequirement + "MinReqs"].append(someKey + "MinReqs")
				elif ":" in someSomeRequirement and "Setting" not in someSomeRequirement and "Boost" not in someSomeRequirement and "NPCI" not in someSomeRequirement:
					if someKey not in NodesNotifyChart[someSomeRequirement]:
						NodesNotifyChart[someSomeRequirement].append(someKey)
						NodesNotifyChart[someSomeRequirement + "MinReqs"].append(someKey + "MinReqs")
				else:
					if someKey not in NodesNotifyChart[someSomeRequirement]:
						NodesNotifyChart[someSomeRequirement].append(someKey)
						NodesNotifyChart[someSomeRequirement + "MinReqs"].append(someKey + "MinReqs")
	for node in listofNodes:
		if "!" in node:
			NodesNotifyChart[node[1:]].append(node)
			NodesNotifyChart[node[1:] + "MinReqs"].append(node + "MinReqs")

	luaString = luaString + "NotificationChart={}\n"
	#pprint.pprint(NodesNotifyChart)
	for Notifier, Notified in NodesNotifyChart.items():
		luaString = luaString + "NotificationChart[\"" + common.sanitize(Notifier) + "\"] = {"
		for N in Notified:
			luaString = luaString + "\"" + common.sanitize(N)+"\","
		luaString = luaString + "}\n"
	for Guardian in listOfGuardians:
		luaString = luaString + "NotificationChart[\"Event" + Guardian + "Defeated\"] = {}\n"
		luaString = luaString + "NotificationChart[\"Event" + Guardian + "DefeatedMinReqs\"] = {}\n"
	luaString = luaString + "CheckFunctionTable={}\n"
	logicDict = {}
	for someKey, listOfRequirements in someSimpleRequirementList.items():	
		if ":" not in someKey:
			someKey = "Vanilla"+someKey
		sanitizedKey = common.sanitize(someKey)
		logicString = '(' # "CheckFunctionTable[\""+sanitizedKey+"\"] = function() return ("
		listOfConditions = []
		for someRequirement in listOfRequirements:
			conditions = []
			for someSomeRequirement in someRequirement:
				if ":" in someSomeRequirement and "Defeated" in someSomeRequirement:
					done=0
					for Guardian in listOfGuardians:
						if Guardian in someSomeRequirement and "Children" not in someSomeRequirement:
							done=1
							conditions.append("NodeStatusArray[\""+Guardian+"\"]")
					if not done:
						conditions.append("NodeStatusArray[\""+common.sanitize(someSomeRequirement)+"\"]")
				else:
					conditions.append("NodeStatusArray[\""+common.sanitize(someSomeRequirement)+"\"]")
			if conditions:
				listOfConditions.append(conditions)
		#if sanitizedKey == "LocationSurfaceMain" or sanitizedKey == "ExitSurfaceMain":
		#	logicString = logicString + "true)"
		if not listOfConditions :
			logicString = logicString + "true)"
		else:
			logicString = logicString + " or ".join("("+(" and ".join(inner))+")" for inner in listOfConditions) + ")"
		logicDict[sanitizedKey] = logicString

	for key, value in logicDict.items():
		simple = common.simplifyRule(value)
		luaString = luaString + "CheckFunctionTable[\"" + key + "\"] = function() return (" + simple + ") end\n"
		sanitizedValue = common.simplifyRule(common.sanitizeRequirementsForIntendedLogic( value ))
		luaString = luaString + "CheckFunctionTable[\"" + key + "MinReqs\"] = function() return (" + sanitizedValue + ") end\n"

	for item in listofInitialChecks:
		logicString="CheckFunctionTable[\""+common.sanitize(item)+"\"] = function() return Tracker:ProviderCountForCode(\"" + common.sanitize(item) + "\") >= 1 end\n"
		luaString = luaString + logicString
		luaString = luaString + common.sanitizeRequirementsForIntendedLogic(logicString)
	for OrbCount in range(1,11):
		luaString = luaString + "CheckFunctionTable[\"SacredOrb"+str(OrbCount)+"\"] = function() return Tracker:ProviderCountForCode(\"SacredOrb\") >= "+str(OrbCount)+" end\n"
		luaString = luaString + "CheckFunctionTable[\"SacredOrb"+str(OrbCount)+"MinReqs\"] = function() return Tracker:ProviderCountForCode(\"SacredOrb\") >= "+str(OrbCount)+" end\n"
	for node in listofNodes:
		if "!" in node:
			luaString = luaString + "CheckFunctionTable[\""+common.sanitize(node)+"\"] = function() return not NodeStatusArray[\""+common.sanitize(node[1:])+"\"] end\n"
			luaString = luaString + "CheckFunctionTable[\""+common.sanitize(node)+"MinReqs\"] = function() return not NodeStatusArray[\""+common.sanitize(node[1:])+"MinReqs\"] end\n"

	for someKey, listOfRequirements in someSimpleRequirementList.items():	
		if ":" not in someKey:
			someKey = "Vanilla"+someKey
		sanitizedKey = common.sanitize(someKey)
		if "Vanilla" in someKey or "Coin:" in someKey or "Trap:" or "NPCL:" in someKey:
			if sanitizedKey == "VanillaAngelShield":
				luaString = luaString + "function " + sanitizedKey + "()\n\tUpdateAvailability()\n\treturn NodeStatusArray[\"" + sanitizedKey +"\"]\nend\n\n"
				luaString = luaString + "function " + sanitizedKey + "MinReqs()\n\treturn NodeStatusArray[\"" + sanitizedKey +"MinReqs\"]\nend\n\n"
			else:
				luaString = luaString + "function " + sanitizedKey + "()\n\treturn NodeStatusArray[\"" + sanitizedKey +"\"]\nend\n\n"
				luaString = luaString + "function " + sanitizedKey + "MinReqs()\n\treturn NodeStatusArray[\"" + sanitizedKey +"MinReqs\"]\nend\n\n"
		if "Event:" in someKey and "Defeated" in someKey:
			for Guardian in listOfGuardians:
				if Guardian in someKey and "Children" not in someKey:
					luaString = luaString + "function " + sanitizedKey + "()\n\treturn NodeStatusArray[\"" + sanitizedKey +"\"]\nend\n\n"
					luaString = luaString + "function " + sanitizedKey + "MinReqs()\n\treturn NodeStatusArray[\"" + sanitizedKey +"MinReqs\"]\nend\n\n"

	luaString=luaString + common.updateAvailabilityFunction
	#luaString=luaString + common.updateAvailabilityWithLoggingFunction
	#	luaString = luaString + "processing" + common.sanitize(someKey) + " = false\n"
	#	luaString = luaString + "function " + common.sanitize(someKey) + "()\n\tif processing" + common.sanitize(someKey) + " then\n\t\treturn 0\n\tend\n\tprocessing" + common.sanitize(someKey) + " = true\n\tif ("
	#	listOfConditions = []
	#	for someRequirement in listOfRequirements:
	#		conditions = []
	#		for someSomeRequirement in someRequirement:
	#			if ":" in someSomeRequirement and "Defeated" in someSomeRequirement:
	#				for Guardian in listOfGuardians:
	#					if Guardian in someSomeRequirement:
	#						conditions.append("Tracker:ProviderCountForCode(\"" + Guardian + "\") >= 1")
	#			elif ":" in someSomeRequirement and "Setting" not in someSomeRequirement and "Boost" not in someSomeRequirement:
	#				conditions.append(common.sanitize(someSomeRequirement) + "() == 1")
	#			else:
	#				conditions.append("Tracker:ProviderCountForCode(\"" + common.sanitize(someSomeRequirement) + "\") >= 1")
	#				if [someSomeRequirement, common.sanitize(someSomeRequirement)] not in listOfItems:
	#					listOfItems.append([someSomeRequirement, common.sanitize(someSomeRequirement)])
	#		listOfConditions.append(conditions)
	#	luaString = luaString + " or ".join("("+(" and ".join(inner))+")" for inner in listOfConditions) + ") then\n\t\tprocessing" + common.sanitize(someKey) + " = false\n\t\treturn 1\n\tend\n\tprocessing" + common.sanitize(someKey) + " = false\n\treturn 0\nend\n\n"
	filePoint.write(luaString)

requirementList = []

def performWork():
	current_path = os.path.dirname(os.path.realpath(__file__))
	logic_file = os.path.join(current_path, "..", "..", "scripts", "logic.lua")
	if os.path.exists(logic_file):
		os.remove(logic_file)
	f = open(logic_file, "a")
	luaString = "NodeStatusArray={}\n"
	f.write(luaString)
	masterList = buildMasterList()
	# masterListDebug = open("debug.json", "w")
	# masterListDebug.write(json.dumps(masterList, indent="\t"))
	# masterListDebug.close()
	masterList["Location: Surface [Main]"].append(["startingAreaLocationIsSurfaceStd"])
	masterList["Location: Gate of Illusion [Grail]"].append(["startingAreaLocationIsIllusionStd"])
	masterList["Location: Gate of Guidance [Main]"].append(["startingAreaLocationIsGuidanceStd"])
	masterList["Location: Mausoleum of the Giants"].append(["startingAreaLocationIsMausoleumStd"])
	masterList["Location: Inferno Cavern [Main]"].append(["startingAreaLocationIsInfernoStd"])
	masterList["Location: Twin Labyrinths [Upper Grail]"].append(["startingAreaLocationIsTwinFStd"])
	masterList["Location: Twin Labyrinths [Upper Left]"].append(["startingAreaLocationIsTwinFStd"]) #Elevator on by default
	masterList["Location: Endless Corridor [1F]"].append(["startingAreaLocationIsEndlessStd"])
	masterList["Location: Twin Labyrinths [Lower]"].append(["startingAreaLocationIsTwinBStd"])
	masterList["Location: Temple of the Sun [Grail]"].append(["startingAreaLocationIsSunStd"])
	masterList["Location: Spring in the Sky [Main]"].append(["startingAreaLocationIsSpringStd"])
	masterList["Location: Temple of Moonlight [Grail]"].append(["startingAreaLocationIsMoonlightStd"])
	masterList["Exit: Surface [Main]"].append(["startingAreaLocationIsSurfaceStd"])
	masterList["Exit: Gate of Illusion [Grail]"].append(["startingAreaLocationIsIllusionStd"])
	masterList["Exit: Gate of Guidance [Main]"].append(["startingAreaLocationIsGuidanceStd"])
	masterList["Exit: Mausoleum of the Giants"].append(["startingAreaLocationIsMausoleumStd"])
	masterList["Exit: Inferno Cavern [Main]"].append(["startingAreaLocationIsInfernoStd"])
	masterList["Exit: Endless Corridor [1F]"].append(["startingAreaLocationIsEndlessStd"])
	masterList["Exit: Twin Labyrinths [Lower]"].append(["startingAreaLocationIsTwinBStd"])
	masterList["Exit: Temple of the Sun [Grail]"].append(["startingAreaLocationIsSunStd"])
	masterList["Exit: Spring in the Sky [Main]"].append(["startingAreaLocationIsSpringStd"])
	masterList["Exit: Temple of Moonlight [Grail]"].append(["startingAreaLocationIsMoonlightStd"])
	masterList["Attack: Pistol"].append(["startingWeaponPistol"])
	luaWriter(masterList, f)
	f.close()

	location_file = os.path.join(current_path, "..", "..", "locations", "locations.json")
	if os.path.exists(location_file):
		os.remove(location_file)
	f = open(location_file, "a")
	locationJson = {}
	locationJson["name"] = "All locations"
	locationJson["chest_unopened_img"] = "images/item_closedChest.png"
	locationJson["chest_opened_img"] = "images/item_openedChest.png"
	locationJson["children"] = []
	index = 0
	for someLocation, someDetails in locationTable.items():
		someCrap = {}
		someCrap["name"] = locationTable[someLocation]["sectionName"]
		sanitizedLocation = common.sanitize(someLocation)
		target = "$"
		if ":" not in someLocation:
			target = "$Vanilla"
		target = target + sanitizedLocation
		if "hostedItem" in someDetails:
			someCrap["hosted_item"] = locationTable[someLocation]["hostedItem"]
			someCrap["access_rules"] = ["[" + target + "], " + target + "MinReqs"]
		#Shop Items only appear in NonrnadomNPC setting
		elif "Shop" in someLocation:
			someCrap["item_count"] = 3
			someCrap["access_rules"] = ["[" + target + "], " + target + "MinReqs, SettingNonrandomNPCs"]
		elif "NPCL:" in someLocation:
			someCrap["item_count"] = 1
			someCrap["access_rules"] = ["[" + target + "], " + target + "MinReqs, SettingRandomNPCs"]
		else:
			someCrap["item_count"] = 1
			someCrap["access_rules"] = ["[" + target + "], " + target + "MinReqs"]
		if "isChild" not in someDetails:
			someItem = {}
			someItem["name"] = locationTable[someLocation]["locationName"]
			someItem["map_locations"] = []
			subMap = {}
			subMap["map"] = locationTable[someLocation]["mapName"]
			subMap["x"] = locationTable[someLocation]["subMapXY"][0]
			subMap["y"] = locationTable[someLocation]["subMapXY"][1]
			someItem["map_locations"].append(subMap)
			worldMap = {}
			worldMap["map"] = "world"
			worldMap["x"] = round(locationTranslation[locationTable[someLocation]["mapName"]][0] + (locationTable[someLocation]["subMapXY"][0] * locationTranslation[locationTable[someLocation]["mapName"]][2]))
			worldMap["y"] = round(locationTranslation[locationTable[someLocation]["mapName"]][1] + (locationTable[someLocation]["subMapXY"][1] * locationTranslation[locationTable[someLocation]["mapName"]][2]))
			someItem["map_locations"].append(worldMap)
			someItem["sections"] = []

			someItem["sections"].append(someCrap)
			locationJson["children"].append(someItem)
			index = index + 1
		else:
			locationJson["children"][index - 1]["sections"].append(someCrap)

	f = open(location_file, "w+")
	f.write(json.dumps([locationJson], indent="\t"))
	f.close()

performWork()
