import javalang, requests, re, json, os, pprint

from parsing import common

locationTable = {}

#Dimensional Corridor
locationTable["Angel Shield"] = {"mapName": "dimensional_corridor", "subMapXY": [318, 1135], "locationName": "Marduk's Room", "sectionName": "Angel Shield location"}
locationTable["Coin: Dimensional"] = {"mapName": "dimensional_corridor", "subMapXY": [1240, 2465], "locationName": "Anshar's Room", "sectionName": "Coin Chest in top right wall"}
locationTable["Map (Dimensional Corridor)"] = {"mapName": "dimensional_corridor", "subMapXY": [1230, 2980], "locationName": "Kishar's Room", "sectionName": "Dimensional Map location"}
locationTable["beolamu.exe"] = {"mapName": "dimensional_corridor", "subMapXY": [960, 1165], "locationName": "Mushnahhu's Room", "sectionName": "Scan the room"}
locationTable["Ankh Jewel (Dimensional Corridor)"] = {"mapName": "dimensional_corridor", "subMapXY": [2140, 1850], "locationName": "Mushussu's Room", "sectionName": "Mushussu's item"}
locationTable["Sacred Orb (Dimensional Corridor)"] = {"mapName": "dimensional_corridor", "subMapXY": [1440, 260], "locationName": "Anu's Room", "sectionName": "Dimensional Orb location"}
locationTable["Magatama Jewel"] = {"mapName": "dimensional_corridor", "subMapXY": [1600, 1300], "locationName": "Tiamat's Room", "sectionName": "Tiamat's Item"}
locationTable["Event: Tiamat Defeated"] = {"mapName": "dimensional_corridor", "subMapXY": [1596, 1057], "locationName": "Tiamat's Room", "sectionName": "Tiamat", "hostedItem": "Tiamat"}

#Chamber of Birth
locationTable["Map (Chamber of Birth)"] = {"mapName": "chamber_of_birth", "subMapXY": [695, 1850], "locationName": "Brahma's Room", "sectionName": "Birth Map location"}
locationTable["Shop 17 (Birth)"] = {"mapName": "chamber_of_birth", "subMapXY": [1357, 1780], "locationName": "Mud Man Qubert's shop", "sectionName": "Store Stock"}
locationTable["Dimensional Key"] = {"mapName": "chamber_of_birth", "subMapXY": [2470, 2255], "locationName": "Asura's Room", "sectionName": "Dimensional Key location"}
locationTable["Pochette Key"] = {"mapName": "chamber_of_birth", "subMapXY": [3770, 2090], "locationName": "Skanda's Room", "sectionName": "Skanda's Item"}
locationTable["Coin: Birth (Dance)"] = {"mapName": "chamber_of_birth", "subMapXY": [2817, 2740], "locationName": "Hanuman's Room", "sectionName": "Coin chest behind pillar"}
locationTable["Coin: Birth (Ninja)"] = {"mapName": "chamber_of_birth", "subMapXY": [2680, 575], "locationName": "Surrounding Wall of Spikes", "sectionName": "Kill a Ninja"}
locationTable["Vessel"] = {"mapName": "chamber_of_birth", "subMapXY": [3780, 895], "locationName": "Surrounding Wall of Spikes", "sectionName": "Golden glow reflects the beam"}
locationTable["Perfume"] = {"mapName": "chamber_of_birth", "subMapXY": [4430, 655], "locationName": "Shiva's Room", "sectionName": "Wait for Mudman"}
locationTable["Coin: Birth (Southeast)"] = {"mapName": "chamber_of_birth", "subMapXY": [4525, 1855], "locationName": "Vishnu's Room", "sectionName": "Coin chest at bottom left"}
locationTable["Woman Statue"] = {"mapName": "chamber_of_birth", "subMapXY": [5170, 1530], "locationName": "Parvati's Room", "sectionName": "Woman Statue location"}

#Endless Corridor
locationTable["Shop 22 (Endless)"] = {"mapName": "endless_corridor", "subMapXY": [1500, 340], "locationName": "Knimare's shop", "sectionName": "Store Stock"}
locationTable["Map (Endless Corridor)"] = {"mapName": "endless_corridor", "subMapXY": [35, 255], "locationName": "First Endless Corridor", "sectionName": "Loop First Corridor"}
locationTable["Key Sword"] = {"mapName": "endless_corridor", "subMapXY": [1640, 815], "locationName": "Second Endless Corridor", "sectionName": "Attack Weapon Seal"}
locationTable["Twin Statue"] = {"mapName": "endless_corridor", "subMapXY": [95, 1060], "locationName": "Third Endless Corridor", "sectionName": "Twin Statue location"}
locationTable["Coin: Endless"] = {"mapName": "endless_corridor", "subMapXY": [1490, 1220], "locationName": "Third Endless Corridor", "sectionName": "Coin Chest in middle left wall"}

#Chamber of Extinction
locationTable["Map (Chamber of Extinction)"] = {"mapName": "chamber_of_extinction", "subMapXY": [858, 1295], "locationName": "Darkness Approach", "sectionName": "Extinction Map location"}
locationTable["Coin: Extinction"] = {"mapName": "chamber_of_extinction", "subMapXY": [1050, 1295], "locationName": "Darkness Approach", "sectionName": "Coin chest on the side with candle of light"}
locationTable["Sacred Orb (Chamber of Extinction)"] = {"mapName": "chamber_of_extinction", "subMapXY": [1320, 1055], "locationName": "Darkness Approach", "sectionName": "Floor switch at top right of room (Extinction Orb location)"}
locationTable["Chakram"] = {"mapName": "chamber_of_extinction", "subMapXY": [1685, 1775], "locationName": "Mural Depicting the Power of Words", "sectionName": "Hekatonkheires' item (Chakram location)"}
locationTable["mantra.exe"] = {"mapName": "chamber_of_extinction", "subMapXY": [2240, 1600], "locationName": "Mural Depicting the Power of Words", "sectionName": "Scan the lit up mural"}
locationTable["Life Seal"] = {"mapName": "chamber_of_extinction", "subMapXY": [3800, 1700], "locationName": "Mural of Light", "sectionName": "Go through the below wall"}
locationTable["Shop 16 (Extinction)"] = {"mapName": "chamber_of_extinction", "subMapXY": [4776, 740], "locationName": "Combaker's shop", "sectionName": "Store Stock"}
locationTable["Event: Palenque Defeated"] = {"mapName": "chamber_of_extinction", "subMapXY": [5429, 1364], "locationName": "Palenque's Room", "sectionName": "Palenque", "hostedItem": "Palenque"}

#Tower of the Goddess
locationTable["Eye of Truth"] = {"mapName": "tower_of_the_goddess", "subMapXY": [325, 2255], "locationName": "Verdandi's Tower", "sectionName": "Eye of Truth location"}
locationTable["Shop 13 (Goddess)"] = {"mapName": "tower_of_the_goddess", "subMapXY": [378, 1380], "locationName": "Energetic Belmont's shop", "sectionName": "Store Stock"}
locationTable["Spaulder"] = {"mapName": "tower_of_the_goddess", "subMapXY": [1780, 145], "locationName": "Path to Life", "sectionName": "Key Fairy"}
locationTable["Coin: Goddess (Shield)"] = {"mapName": "tower_of_the_goddess", "subMapXY": [2735, 415], "locationName": "Path to Power", "sectionName": "Coin chest left of bottom pot"}
locationTable["Plane Model"] = {"mapName": "tower_of_the_goddess", "subMapXY": [2240, 675], "locationName": "Skuld's Tower", "sectionName": "Foothold in front of statues"}
locationTable["Flail Whip"] = {"mapName": "tower_of_the_goddess", "subMapXY": [1600, 1855], "locationName": "Scales of the Heart", "sectionName": "Balance the Spirits (2xR, 3xL, 2xR, stand left)"}
locationTable["Coin: Goddess (Fairy)"] = {"mapName": "tower_of_the_goddess", "subMapXY": [1200, 2015], "locationName": "Urd's Tower", "sectionName": "Floor switch next to pipe"}
locationTable["Map (Tower of the Goddess)"] = {"mapName": "tower_of_the_goddess", "subMapXY": [1865, 3770], "locationName": "Anterior Chamber", "sectionName": "Behind collapsed tower"}

#Graveyard of the Giants
locationTable["Shop 7 (Graveyard)"] = {"mapName": "graveyard_of_giants", "subMapXY": [120, 420], "locationName": "Giant Mopiran's shop", "sectionName": "Store Stock"}
locationTable["Silver Shield"] = {"mapName": "graveyard_of_giants", "subMapXY": [1060, 655], "locationName": "White Silver Altar", "sectionName": "Break the floor from above"}
locationTable["Coin: Graveyard"] = {"mapName": "graveyard_of_giants", "subMapXY": [1845, 95], "locationName": "First Tomb", "sectionName": "Coin Chest on the cliff top right"}
locationTable["Map (Graveyard of the Giants)"] = {"mapName": "graveyard_of_giants", "subMapXY": [2345, 1055], "locationName": "Path to the Graveyard", "sectionName": "Drop the ice above"}
locationTable["Gauntlet"] = {"mapName": "graveyard_of_giants", "subMapXY": [2075, 1535], "locationName": "Path to the Graveyard", "sectionName": "Gauntlet location"}
locationTable["mirai.exe"] = {"mapName": "graveyard_of_giants", "subMapXY": [1020, 2340], "locationName": "Third Tomb", "sectionName": "Jump to the dias from the left"}
locationTable["emusic.exe"] = {"mapName": "graveyard_of_giants", "subMapXY": [3460, 1695], "locationName": "Altar of Knowledge", "sectionName": "Scan on the Bombed Wall"}
locationTable["Bomb"] = {"mapName": "graveyard_of_giants", "subMapXY": [2880, 1295], "locationName": "Altar of Power", "sectionName": "Kamaitachi's item"}
locationTable["Trap: Graveyard"] = {"mapName": "graveyard_of_giants", "subMapXY": [2515, 2820], "locationName": "Path to the Graveyard", "sectionName": "Monster Trap chest"}

#Gate of Guidance
locationTable["Sacred Orb (Gate of Guidance)"] = {"mapName": "gate_of_guidance", "subMapXY": [2300, 100], "locationName": "Pillars Gate", "sectionName": "Guidance Orb Location"}
locationTable["Treasures"] = {"mapName": "gate_of_guidance", "subMapXY": [1617, 190], "locationName": "Pillars Gate", "sectionName": "Pepper turn in"}
locationTable["Crucifix"] = {"mapName": "gate_of_guidance", "subMapXY": [3060, 900], "locationName": "Heavenly Temple of the Cross", "sectionName": "Offer 3 lights to the heavens"}
locationTable["Shuriken"] = {"mapName": "gate_of_guidance", "subMapXY": [3540, 660], "locationName": "Room of Courage", "sectionName": "Prove thine courage"}
locationTable["Coin: Guidance (One)"] = {"mapName": "gate_of_guidance", "subMapXY": [4140, 900], "locationName": "Room of Courage", "sectionName": "Coin Chest 1"}
locationTable["Coin: Guidance (Two)"] = {"mapName": "gate_of_guidance", "subMapXY": [4300, 720], "locationName": "Room of Courage", "sectionName": "Coin Chest 2"}
locationTable["Map (Gate of Guidance)"] = {"mapName": "gate_of_guidance", "subMapXY": [1760, 1220], "locationName": "Heavenly Corridor", "sectionName": "Guidance Map Location"}
locationTable["Holy Grail"] = {"mapName": "gate_of_guidance", "subMapXY": [1100, 1620], "locationName": "Pit of the Holy Grail", "sectionName": "Block pushing from fake wall"}
locationTable["Coin: Guidance (Trap)"] = {"mapName": "gate_of_guidance", "subMapXY": [1850, 1800], "locationName": "Gate of Giant Faces", "sectionName": "Jump from the trap door"}
locationTable["Shop 4 (Guidance)"] = {"mapName": "gate_of_guidance", "subMapXY": [858, 2662], "locationName": "Penadvent of ghost shop", "sectionName": "Store Stock"}
locationTable["Ankh Jewel (Gate of Guidance)"] = {"mapName": "gate_of_guidance", "subMapXY": [2277, 2340], "locationName": "Cliff of Radiance", "sectionName": "4 extinction event"}
locationTable["yagostr.exe"] = {"mapName": "gate_of_guidance", "subMapXY": [35, 1300], "locationName": "Door to Eden", "sectionName": "Come from Ruin Door"}
locationTable["Event: Amphisbaena Defeated"] = {"mapName": "gate_of_guidance", "subMapXY": [2882, 2326], "locationName": "Amphisbaena's Room", "sectionName": "Amphisbaena", "hostedItem": "Amphisbaena"}

#Gate of Illusion
locationTable["Coin: Illusion (Spikes)"] = {"mapName": "gate_of_illusion", "subMapXY": [3305, 2660], "locationName": "Entrance of Illusion", "sectionName": "Coin chest in the wall above spikes"}
locationTable["Trap: Exploding"] = {"mapName": "gate_of_illusion", "subMapXY": [2210, 2085], "locationName": "Fool's Confusion Corridor", "sectionName": "Trap Chest"}
locationTable["Map (Gate of Illusion)"] = {"mapName": "gate_of_illusion", "subMapXY": [2100, 2170], "locationName": "Fool's Confusion Corridor", "sectionName": "Real chest (Illusion Map loction)"}
locationTable["Pepper"] = {"mapName": "gate_of_illusion", "subMapXY": [3259, 1343], "locationName": "Sacred Lake of the Sky", "sectionName": "Mr. Slushfund's Request (Pepper location)"}
locationTable["Anchor"] = {"mapName": "gate_of_illusion", "subMapXY": [3259, 1343], "locationName": "Sacred Lake of the Sky", "sectionName": "Treasure Turn In", "isChild": True, "childOf": "Pepper"}
locationTable["Mini Doll"] = {"mapName": "gate_of_illusion", "subMapXY": [3700, 2020], "locationName": "Priest Alest", "sectionName": "Mini doll location"}
locationTable["Shop 5 (Illusion)"] = {"mapName": "gate_of_illusion", "subMapXY": [580, 1225], "locationName": "Mover Athleland's shop", "sectionName": "Store Stock"}
locationTable["Fairy Clothes"] = {"mapName": "gate_of_illusion", "subMapXY": [60, 1620], "locationName": "Mausoleum of Fairies", "sectionName": "Key fairy unlock"}
locationTable["Coin: Illusion (Katana)"] = {"mapName": "gate_of_illusion", "subMapXY": [595, 1860], "locationName": "Mausoleum of Fairies", "sectionName": "Katana wall"}
locationTable["Key of Eternity"] = {"mapName": "gate_of_illusion", "subMapXY": [2240, 1850], "locationName": "Chi You's Room", "sectionName": "Chi You's item"}
locationTable["Cog of the Soul"] = {"mapName": "gate_of_illusion", "subMapXY": [2900, 340], "locationName": "Cog of Life", "sectionName": "The Key of Life"}

#Inferno Cavern
locationTable["Ice Cape"] = {"mapName": "inferno_cavern", "subMapXY": [4430, 2015], "locationName": "Treasury of Ice", "sectionName": "Ice Cape Location"}
locationTable["bunplus.com"] = {"mapName": "inferno_cavern", "subMapXY": [3345, 2020], "locationName": "Treasury of Ice", "sectionName": "Hidden in the wall (Bunplus Location)"}
locationTable["Shop 14 (Inferno)"] = {"mapName": "inferno_cavern", "subMapXY": [2680, 1540], "locationName": "Nemesistwo's shop", "sectionName": "Store Stock"}
locationTable["Flare Gun"] = {"mapName": "inferno_cavern", "subMapXY": [1355, 1775], "locationName": "Serdab of Light", "sectionName": "Block Puzzle"}
locationTable["Chain Whip"] = {"mapName": "inferno_cavern", "subMapXY": [320, 1135], "locationName": "Pylon of Power", "sectionName": "Pazuzu's item"}
locationTable["Trap: Inferno Orb"] = {"mapName": "inferno_cavern", "subMapXY": [2750, 660], "locationName": "Twin's Footstool", "sectionName": "In plain sight"}
locationTable["Coin: Inferno (Lava)"] = {"mapName": "inferno_cavern", "subMapXY": [3145, 815], "locationName": "Twin's Footstool", "sectionName": "Break the wall in lava from screen to the right"}
locationTable["Coin: Inferno (Spikes)"] = {"mapName": "inferno_cavern", "subMapXY": [1635, 170], "locationName": "Echidna's Chamber", "sectionName": "Coin chest in the wall next to ladder"}
locationTable["Map (Inferno Cavern)"] = {"mapName": "inferno_cavern", "subMapXY": [2615, 175], "locationName": "Twin's Footstool", "sectionName": "Enrage the snakes"}
locationTable["Event: Viy Defeated"] = {"mapName": "inferno_cavern", "subMapXY": [2409, 2490], "locationName": "Viy's Room", "sectionName": "Viy", "hostedItem": "Viy"}


#Mausoleum of Giants
locationTable["Coin: Mausoleum"] = {"mapName": "mausoleum_of_giants", "subMapXY": [1475, 340], "locationName": "Last Shrine", "sectionName": "Coin chest in the wall"}
locationTable["Rolling Shuriken"] = {"mapName": "mausoleum_of_giants", "subMapXY": [315, 650], "locationName": "Shrine of the Giants", "sectionName": "Ghost Lord's item"}
locationTable["Map (Mausoleum of the Giants)"] = {"mapName": "mausoleum_of_giants", "subMapXY": [1650, 575], "locationName": "Approach of the Giants", "sectionName": "Mausoleum Map location"}
locationTable["Ankh Jewel (Mausoleum of the Giants)"] = {"mapName": "mausoleum_of_giants", "subMapXY": [4390, 1130], "locationName": "Dolphin's Room", "sectionName": "Mausoleum Jewel location"}
locationTable["Shop 6 (Mausoleum)"] = {"mapName": "mausoleum_of_giants", "subMapXY": [3478, 1305], "locationName": "Greedy Charlie's shop", "sectionName": "Store Stock"}
locationTable["Sacred Orb (Mausoleum of the Giants)"] = {"mapName": "mausoleum_of_giants", "subMapXY": [3460, 1615], "locationName": "Star Palace of the Giants", "sectionName": "Strength at the foot of Futo"}
locationTable["Event: Sakit Defeated"] = {"mapName": "mausoleum_of_giants", "subMapXY": [1663, 2103], "locationName": "Sakit's Room", "sectionName": "Sakit", "hostedItem": "Sakit"}

#Temple of Moonlight
locationTable["Philosopher's Ocarina"] = {"mapName": "temple_of_moonlight", "subMapXY": [2240, 1295], "locationName": "Moon Pyramid: Burial Chamber", "sectionName": "Sleep within the woman"}
locationTable["Fruit of Eden"] = {"mapName": "temple_of_moonlight", "subMapXY": [1880, 745], "locationName": "Neptune's Feet", "sectionName": "Eden Seeking"}
locationTable["Axe"] = {"mapName": "temple_of_moonlight", "subMapXY": [715, 1210], "locationName": "Serdab of Power", "sectionName": "Rolling Rock"}
locationTable["Coin: Moonlight"] = {"mapName": "temple_of_moonlight", "subMapXY": [1040, 170], "locationName": "Stairway of Eden", "sectionName": "Attack the spiked wall"}
locationTable["Grapple Claw"] = {"mapName": "temple_of_moonlight", "subMapXY": [320, 175], "locationName": "Boneyard", "sectionName": "Grapple Claw location"}
locationTable["Map (Temple of Moonlight)"] = {"mapName": "temple_of_moonlight", "subMapXY": [1025, 735], "locationName": "Moonlight Map location", "sectionName": "Beware of spikes"}
locationTable["Serpent Staff"] = {"mapName": "temple_of_moonlight", "subMapXY": [2500, 2810], "locationName": "Underworld Palace", "sectionName": "Anubis's item"}
locationTable["Shop 11 (Moonlight)"] = {"mapName": "temple_of_moonlight", "subMapXY": [3758, 1535], "locationName": "Kingvalley II's shop", "sectionName": "Store Stock"}

#Surface
locationTable["Feather"] = {"mapName": "surface", "subMapXY": [195, 1061], "locationName": "Village Altar", "sectionName": "Village Altar"}
locationTable["Shop 1 (Surface)"] = {"mapName": "surface", "subMapXY": [4360, 1700], "locationName": "Modro's Shop", "sectionName": "Store Stock"}
locationTable["Shop 2 (Surface)"] = {"mapName": "surface", "subMapXY": [3580, 1420], "locationName": "Nebur's shop", "sectionName": "Initial Stock"}
locationTable["Shop 2 Alt (Surface)"] = {"mapName": "surface", "subMapXY": [3580, 1420], "locationName": "Nebur's shop", "sectionName": "4 Guardian Item", "isChild": True, "childOf": "Shop 2 (Surface)"}
locationTable["xmailer.exe"] = {"mapName": "surface", "subMapXY": [4041, 1420], "locationName": "Xelpud", "sectionName": "First item (xmailer item)"}
locationTable["Mulana Talisman"] = {"mapName": "surface", "subMapXY": [4041, 1420], "locationName": "Xelpud", "sectionName": "Diary turn in", "isChild": True, "childOf": "Mulana Talisman"}
locationTable["Shop 3 (Surface)"] = {"mapName": "surface", "subMapXY": [4100, 1780], "locationName": "Sidro's Shop", "sectionName": "Store Stock"}
locationTable["deathv.exe"] = {"mapName": "surface", "subMapXY": [5385, 1296], "locationName": "Behind Xelpud Statue", "sectionName": "Behind Xelpud Statue"}
locationTable["Map (Surface)"] = {"mapName": "surface", "subMapXY": [5437, 1070], "locationName": "Scan Skeleton", "sectionName": "Scan Skeleton (Surface Map location)"}
locationTable["Shell Horn"] = {"mapName": "surface", "subMapXY": [5250, 730], "locationName": "Sound Canyon", "sectionName": "Shell Horn Location"}
locationTable["Coin: Surface (Waterfall)"] = {"mapName": "surface", "subMapXY": [6530, 415], "locationName": "Bahrun's Waterfall", "sectionName": "Coin Chest Above Waterfall"}
locationTable["mekuri.exe"] = {"mapName": "surface", "subMapXY": [6760, 820], "locationName": "Bahrun's Waterfall", "sectionName": "Nigoro Maniac (Mekuri Location)"}
locationTable["Birth Seal"] = {"mapName": "surface", "subMapXY": [7580, 735], "locationName": "Bahrun's Waterfall", "sectionName": "High chest behind the right Waterfall"}
locationTable["Sacred Orb (Surface)"] = {"mapName": "surface", "subMapXY": [7510, 1175], "locationName": "Waterfall of the Goddess", "sectionName": "Low chest behind the right Waterfall"}
locationTable["Coin: Surface (Ruin Path)"] = {"mapName": "surface", "subMapXY": [6300, 730], "locationName": "Gazing Hill", "sectionName": "Coin Chest in Bomb Wall"}
locationTable["Coin: Surface (Seal)"] = {"mapName": "surface", "subMapXY": [2469, 1380], "locationName": "Cliff in front of the Altar", "sectionName": "Coin Chest above Hot Spring"}

#Tower of Ruin
locationTable["Map (Tower of Ruin)"] = {"mapName": "tower_of_ruin", "subMapXY": [915, 1210], "locationName": "Approach of the Philosophers", "sectionName": "Top corridor from Eden"}
locationTable["Shop 15 (Ruin)"] = {"mapName": "tower_of_ruin", "subMapXY": [1600, 1060], "locationName": "Efspi's shop", "sectionName": "Store Stock"}
locationTable["Earth Spear"] = {"mapName": "tower_of_ruin", "subMapXY": [2620, 2015], "locationName": "Fountain of Heat", "sectionName": "Earth Spear location"}
locationTable["Ankh Jewel (Tower of Ruin)"] = {"mapName": "tower_of_ruin", "subMapXY": [3520, 1770], "locationName": "Monument of Name", "sectionName": "Name the nameless one (mid left, top right)"}
locationTable["Sacred Orb (Tower of Ruin)"] = {"mapName": "tower_of_ruin", "subMapXY": [4185, 2095], "locationName": "Fountain of Heat", "sectionName": "Dais behind the Crusher (Ruins Orb location)"}
locationTable["Coin: Ruin"] = {"mapName": "tower_of_ruin", "subMapXY": [2600, 820], "locationName": "Approach of Life", "sectionName": "Subweapon only wall breaking"}
locationTable["Djed Pillar"] = {"mapName": "tower_of_ruin", "subMapXY": [3115, 415], "locationName": "Nuwa's Pyramid", "sectionName": "Nuwa's item"}

#Shrine of the Mother
locationTable["bounce.exe"] = {"mapName": "shrine_of_the_mother", "subMapXY": [2940, 1535], "locationName": "Palenque's Room", "sectionName": "Subweapon only Totem"}
locationTable["Coin: Shrine"] = {"mapName": "shrine_of_the_mother", "subMapXY": [675, 2250], "locationName": "Viy's Room", "sectionName": "Katana only Totem"}
locationTable["Diary"] = {"mapName": "shrine_of_the_mother", "subMapXY": [3150, 590], "locationName": "Ellmac's Room", "sectionName": "Show Talisman to Xelpud"}
locationTable["Crystal Skull"] = {"mapName": "shrine_of_the_mother", "subMapXY": [720, 820], "locationName": "Sakit's Room", "sectionName": "Crystal Skull location"}
locationTable["Sacred Orb (Shrine of the Mother)"] = {"mapName": "shrine_of_the_mother", "subMapXY": [1600, 905], "locationName": "Sakit's Room", "sectionName": "Four Seals (Shrine Orb location)"}
locationTable["Death Seal"] = {"mapName": "shrine_of_the_mother", "subMapXY": [3410, 1385], "locationName": "Treasury", "sectionName": "Philosopher's ladder from Endless Corridor"}
locationTable["Map (Shrine of the Mother)"] = {"mapName": "shrine_of_the_mother", "subMapXY": [585, 1220], "locationName": "Treasury", "sectionName": "Shrine Map location (Up from Twin Labyrinth)"}

#Spring in the Sky
locationTable["Sacred Orb (Spring in the Sky)"] = {"mapName": "spring_in_the_sky", "subMapXY": [318, 1540], "locationName": "Mural of Oannes", "sectionName": "Birth Seal to spawn the ladder"}
locationTable["Caltrops"] = {"mapName": "spring_in_the_sky", "subMapXY": [960, 2500], "locationName": "Goddess's Water Jug", "sectionName": "Sinking floor (Caltrop location)"}
locationTable["Coin: Spring"] = {"mapName": "spring_in_the_sky", "subMapXY": [800, 3930], "locationName": "Anunnaki's Stone Basin", "sectionName": "Through the fake wall from the right"}
locationTable["Ankh Jewel (Spring in the Sky)"] = {"mapName": "spring_in_the_sky", "subMapXY": [1840, 3450], "locationName": "Oannes's Waterfall", "sectionName": "Attack Gyonin"}
locationTable["Map (Spring in the Sky)"] = {"mapName": "spring_in_the_sky", "subMapXY": [1745, 2655], "locationName": "Goddess's Water Jug", "sectionName": "Spring Map location"}
locationTable["Glove"] = {"mapName": "spring_in_the_sky", "subMapXY": [1440, 2015], "locationName": "Sacred Lake", "sectionName": "Open the floodgate"}
locationTable["Shop 12 (Spring)"] = {"mapName": "spring_in_the_sky", "subMapXY": [2517, 1620], "locationName": "Gyonin's Shop", "sectionName": "Store Stock"}
locationTable["Shop 12 Alt (Spring)"] = {"mapName": "spring_in_the_sky", "subMapXY": [2120, 1520], "locationName": "Gyonin's Shop", "sectionName": "Secret Stock"}
locationTable["Scalesphere"] = {"mapName": "spring_in_the_sky", "subMapXY": [1975, 180], "locationName": "Waterfall Approach", "sectionName": "Scalesphere location"}
locationTable["Origin Seal"] = {"mapName": "spring_in_the_sky", "subMapXY": [2620, 660], "locationName": "Room of Origin", "sectionName": "Nuckelavee's item"}
locationTable["Event: Bahamut Defeated"] = {"mapName": "spring_in_the_sky", "subMapXY": [1676, 862], "locationName": "Bahamut's Room", "sectionName": "Bahamut", "hostedItem": "Bahamut"}

#Temple of the Sun
locationTable["Isis' Pendant"] = {"mapName": "temple_of_sun", "subMapXY": [325, 260], "locationName": "Isis's room", "sectionName": "Read the tablet for the dias"}
locationTable["Map (Temple of the Sun)"] = {"mapName": "temple_of_sun", "subMapXY": [1860, 335], "locationName": "Watchtower", "sectionName": "Disappearing ladder"}
locationTable["Knife"] = {"mapName": "temple_of_sun", "subMapXY": [2180, 655], "locationName": "Altar of War", "sectionName": "Aim and Shoot"}
locationTable["Shop 8 (Sun)"] = {"mapName": "temple_of_sun", "subMapXY": [2180, 815], "locationName": "Shalom III's shop", "sectionName": "Store Stock"}
locationTable["Book of the Dead"] = {"mapName": "temple_of_sun", "subMapXY": [1759, 1215], "locationName": "Mulbruk", "sectionName": "Item after visiting Anubis"}
locationTable["Coin: Sun (Pyramid)"] = {"mapName": "temple_of_sun", "subMapXY": [2830, 1500], "locationName": "Sun Pyramid: Burial Chamber", "sectionName": "Chest in bombable wall"}
locationTable["Sacred Orb (Temple of the Sun)"] = {"mapName": "temple_of_sun", "subMapXY": [2320, 1775], "locationName": "Great Colonnade: Left-side room", "sectionName": "Kill the bats"}
locationTable["Shop 10 (Sun)"] = {"mapName": "temple_of_sun", "subMapXY": [1080, 2100], "locationName": "Kingvalley I's shop", "sectionName": "Store Stock"}
locationTable["Shop 9 (Sun)"] = {"mapName": "temple_of_sun", "subMapXY": [2758, 2335], "locationName": "Usas VI's shop", "sectionName": "Store Stock"}
locationTable["Ankh Jewel (Temple of the Sun)"] = {"mapName": "temple_of_sun", "subMapXY": [685, 2040], "locationName": "Horus' Room of Pillars", "sectionName": "Meditate under Wedjet"}
locationTable["Talisman"] = {"mapName": "temple_of_sun", "subMapXY": [3705, 1290], "locationName": "Great Colonnade: Right-side room", "sectionName": "Viy's item"}
locationTable["Bronze Mirror"] = {"mapName": "temple_of_sun", "subMapXY": [4200, 1645], "locationName": "Altar of Mirrors", "sectionName": "Bronze Mirror location"}
locationTable["Event: Ellmac Defeated"] = {"mapName": "temple_of_sun", "subMapXY": [2298, 2734], "locationName": "Ellmac's Room", "sectionName": "Ellmac", "hostedItem": "Ellmac"}

#Twin Labyrinths
locationTable["Shop 19 (Big Bro)"] = {"mapName": "twin_labyrinths", "subMapXY": [6078, 1535], "locationName": "Big Brother's shop", "sectionName": "Store Stock"}
locationTable["Shop 18 (Lil Bro)"] = {"mapName": "twin_labyrinths", "subMapXY": [318, 1535], "locationName": "Little Brother's shop", "sectionName": "Store Stock"}
locationTable["Trap: Twin Ankh"] = {"mapName": "twin_labyrinths", "subMapXY": [6355, 655], "locationName": "Twin's Surrounding Wall", "sectionName": "Plain Sight"}
locationTable["Sacred Orb (Twin Labyrinths)"] = {"mapName": "twin_labyrinths", "subMapXY": [1450, 1325], "locationName": "Demon Altar", "sectionName": "Hidden dais above the passage"}
locationTable["Shop 21 (Unsolvable)"] = {"mapName": "twin_labyrinths", "subMapXY": [2498, 1535], "locationName": "Metagear's shop", "sectionName": "Store Stock"}
locationTable["Shop 20 (Twin Labs)"] = {"mapName": "twin_labyrinths", "subMapXY": [3900, 1535], "locationName": "Sturdy Snake's shop", "sectionName": "Store Stock"}
locationTable["Map (Twin Labyrinths)"] = {"mapName": "twin_labyrinths", "subMapXY": [2470, 655], "locationName": "Zodiac", "sectionName": "Twin Map location (Break the wall right to ladder)"}
locationTable["Ankh Jewel (Twin Labyrinths)"] = {"mapName": "twin_labyrinths", "subMapXY": [4103, 580], "locationName": "Zodiac", "sectionName": "Twin Jewel location (Confer light upon the twins)"}
locationTable["Katana"] = {"mapName": "twin_labyrinths", "subMapXY": [5440, 575], "locationName": "Zodiac", "sectionName": "Katana location"}
locationTable["Ring"] = {"mapName": "twin_labyrinths", "subMapXY": [960, 575], "locationName": "Zodiac", "sectionName": "Ring location"}
locationTable["Coin: Twin (Lower)"] = {"mapName": "twin_labyrinths", "subMapXY": [890, 1690], "locationName": "Zu's Room", "sectionName": "Coin Chest in the wall"}
locationTable["Coin: Twin (Witches)"] = {"mapName": "twin_labyrinths", "subMapXY": [4820, 1135], "locationName": "Demon Altar", "sectionName": "Hidden breakable wall above the passage"}
locationTable["Coin: Twin (Escape)"] = {"mapName": "twin_labyrinths", "subMapXY": [1220, 650], "locationName": "Zodiac", "sectionName": "Coin Chest (Escape)"}
locationTable["Event: Baphomet Defeated"] = {"mapName": "twin_labyrinths", "subMapXY": [2244, 1053], "locationName": "Baphomet's Room", "sectionName": "Baphomet", "hostedItem": "Baphomet"}

#Gate of Time
locationTable["lamulana.exe"] = {"mapName": "gate_of_time", "subMapXY": [930, 252], "locationName": "Retro Surface", "sectionName": "In the Ladder Wall"}

#Hell Temple
locationTable["Shop 23 (HT)"] = {"mapName": "hell_temple", "subMapXY": [1836, 2000], "locationName": "Hell Temple", "sectionName": "Draucet's Shop"}
locationTable["Provocative Bathing Suit"] = {"mapName": "hell_temple", "subMapXY": [1600, 5060], "locationName": "Hell Temple", "sectionName": "Draucet's Gift"}

#Transitions
locationTable["Transition: Surface R1"] = {"mapName": "surface", "subMapXY": [5714, 2244], "locationName": "SurfaceR1", "sectionName": "Vanilla Surface to Guidance"}
#This is One way
#locationTable["TransitionLocation: Surface R1"]={"mapName": "surface", "subMapXY": [5714, 2244], "locationName": "Surface_Main", "sectionName": "Surface_Main", "hostedItem": "LocationSurfaceMain", "isChild": True, "childOf": "Transition: Surface R1"}
locationTable["RuinDoor: Surface [Main]"]= {"mapName": "surface", "subMapXY": [6620, 1290], "locationName": "Ruin Door(Surface)", "sectionName": "Vanilla Surface to Goddess"}
locationTable["TransitionLocation: Surface Door"]={"mapName": "surface", "subMapXY": [6620, 1290], "locationName": "Ruin Door(Surface)", "sectionName": "Ruin Door(Surface)", "hostedItem": "DoorB5", "isChild": True, "childOf": "RuinDoor: Surface [Main]"}

locationTable["Transition: Surface D1"] = {"mapName": "surface", "subMapXY": [5575, 1380], "locationName": "SurfaceD1", "sectionName": "Vanilla Surface to Inferno"}
locationTable["TransitionLocation: Surface [Ruin Path Lower]"]={"mapName": "surface", "subMapXY": [5575, 1380], "locationName": "SurfaceD1", "sectionName": "SurfaceD1", "hostedItem": "TransitionSurfaceD1", "isChild": True, "childOf": "Transition: Surface D1"}

locationTable["Transition: Surface D2"] = {"mapName": "surface", "subMapXY": [6225, 1390], "locationName": "SurfaceD2", "sectionName": "Vanilla Surface to Extinction"}
locationTable["TransitionLocation: Surface [Ruin Path Upper]"]={"mapName": "surface", "subMapXY": [6225, 1390], "locationName": "SurfaceD2", "sectionName": "SurfaceD2", "hostedItem": "TransitionSurfaceD2", "isChild": True, "childOf": "Transition: Surface D2"}

locationTable["Transition: Guidance L1"] = {"mapName": "gate_of_guidance", "subMapXY": [1325, 325], "locationName": "GuidanceL1", "sectionName": "Vanilla Guidance to Surface"}
locationTable["TransitionLocation: Guidance L1"] = {"mapName": "gate_of_guidance", "subMapXY": [1325, 325], "locationName": "GuidanceL1", "sectionName": "Vanilla Guidance to Surface", "hostedItem": "TransitionGuidanceL1", "isChild": True, "childOf": "Transition: Guidance L1"}
locationTable["Transition: Guidance U1"] = {"mapName": "gate_of_guidance", "subMapXY": [4390, 560], "locationName": "GuidanceU1", "sectionName": "Vanilla Guidance to Spring"}
locationTable["TransitionLocation: Guidance U1"] = {"mapName": "gate_of_guidance", "subMapXY": [4390, 560], "locationName": "GuidanceU1", "sectionName": "Vanilla Guidance to Spring", "hostedItem": "TransitionGuidanceU1", "isChild": True, "childOf": "Transition: Guidance U1"}
locationTable["Transition: Guidance D1"] = {"mapName": "gate_of_guidance", "subMapXY": [75, 2825], "locationName": "GuidanceD1", "sectionName": "Vanilla Guidance to Mausoleum"}
locationTable["TransitionLocation: Guidance D1"] = {"mapName": "gate_of_guidance", "subMapXY": [75, 2825], "locationName": "GuidanceD1", "sectionName": "Vanilla Guidance to Mausoleum", "hostedItem": "TransitionGuidanceD1", "isChild": True, "childOf": "Transition: Guidance D1"}
locationTable["Transition: Guidance D2"] = {"mapName": "gate_of_guidance", "subMapXY": [2475, 2345], "locationName": "GuidanceD2", "sectionName": "Vanilla Guidance to Sun"}
locationTable["TransitionLocation: Guidance D2"] = {"mapName": "gate_of_guidance", "subMapXY": [2475, 2345], "locationName": "GuidanceD2", "sectionName": "Vanilla Guidance to Sun", "hostedItem": "TransitionGuidanceD2", "isChild": True, "childOf": "Transition: Guidance D2"}

locationTable["RuinDoor: Gate of Guidance [Door]"]= {"mapName": "gate_of_guidance", "subMapXY": [200, 1135], "locationName": "Ruin Door(Guidance)", "sectionName": "Vanilla Guidance to Illusion"}
locationTable["TransitionLocation: Guidance Door"]={"mapName": "gate_of_guidance", "subMapXY": [200, 1135], "locationName": "Ruin Door(Guidance)", "sectionName": "Ruin Door(Guidance)", "hostedItem": "DoorB1", "isChild": True, "childOf": "RuinDoor: Gate of Guidance [Door]"}


locationTable["Transition: Mausoleum L1"] = {"mapName": "mausoleum_of_giants", "subMapXY": [680, 2250], "locationName": "MausoleumL1", "sectionName": "Vanilla Mausoleum to Endless"}
locationTable["TransitionLocation: Mausoleum L1"] = {"mapName": "mausoleum_of_giants", "subMapXY": [680, 2250], "locationName": "MausoleumL1", "sectionName": "Vanilla Mausoleum to Endless", "hostedItem": "TransitionMausoleumL1", "isChild": True, "childOf": "Transition: Mausoleum L1"}
locationTable["Transition: Mausoleum U1"] = {"mapName": "mausoleum_of_giants", "subMapXY": [710, 70], "locationName": "MausoleumU1", "sectionName": "Vanilla Mausoleum to Guidance"}
locationTable["TransitionLocation: Mausoleum U1"] = {"mapName": "mausoleum_of_giants", "subMapXY": [710, 70], "locationName": "MausoleumU1", "sectionName": "Vanilla Mausoleum to Guidance", "hostedItem": "TransitionMausoleumU1", "isChild": True, "childOf": "Transition: Mausoleum U1"}
locationTable["Transition: Mausoleum D1"] = {"mapName": "mausoleum_of_giants", "subMapXY": [4980, 1860], "locationName": "MausoleumD1", "sectionName": "Vanilla Mausoleum to Twin"}
locationTable["TransitionLocation: Mausoleum D1"] = {"mapName": "mausoleum_of_giants", "subMapXY": [4980, 1860], "locationName": "MausoleumD1", "sectionName": "Vanilla Mausoleum to Twin", "hostedItem": "TransitionMausoleumD1", "isChild": True, "childOf": "Transition: Mausoleum D1"}
locationTable["RuinDoor: Mausoleum of the Giants"]= {"mapName": "mausoleum_of_giants", "subMapXY": [2020, 1290], "locationName": "Ruin Door(Mausoleum)", "sectionName": "Vanilla Mausoleum to Graveyard"}
locationTable["TransitionLocation: Mausoleum Door"]={"mapName": "mausoleum_of_giants", "subMapXY": [2020, 1290], "locationName": "Ruin Door(Mausoleum)", "sectionName": "Ruin Door(Mausoleum)", "hostedItem": "DoorB2", "isChild": True, "childOf": "RuinDoor: Mausoleum of the Giants"}


locationTable["Transition: Sun L1"] = {"mapName": "temple_of_sun", "subMapXY": [60, 645], "locationName": "SunL1", "sectionName": "Vanilla Sun to Inferno"}
locationTable["TransitionLocation: Sun L1"] = {"mapName": "temple_of_sun", "subMapXY": [60, 645], "locationName": "SunL1", "sectionName": "Vanilla Sun to Inferno", "hostedItem": "TransitionSunL1", "isChild": True, "childOf": "Transition: Sun L1"}
locationTable["Transition: Sun U1"] = {"mapName": "temple_of_sun", "subMapXY": [1200, 60], "locationName": "SunU1", "sectionName": "Vanilla Sun to Guidance"}
locationTable["TransitionLocation: Sun U1"] = {"mapName": "temple_of_sun", "subMapXY": [1200, 60], "locationName": "SunU1", "sectionName": "Vanilla Sun to Guidance", "hostedItem": "TransitionSunU1", "isChild": True, "childOf": "Transition: Sun U1"}
locationTable["Transition: Sun R1"] = {"mapName": "temple_of_sun", "subMapXY": [4420, 1515], "locationName": "SunR1", "sectionName": "Vanilla Sun to Extinction Upper","VisibleBeforeAvailable": "LocationTempleoftheSunEast"}
locationTable["TransitionLocation: Sun R1"] = {"mapName": "temple_of_sun", "subMapXY": [4420, 1515], "locationName": "SunR1", "sectionName": "Vanilla Sun to Extinction Upper", "hostedItem": "TransitionSunR1", "isChild": True, "childOf": "Transition: Sun R1"}
locationTable["Transition: Sun R2"] = {"mapName": "temple_of_sun", "subMapXY": [4420, 1690], "locationName": "SunR2", "sectionName": "Vanilla Sun to Extinction Lower","VisibleBeforeAvailable": "LocationTempleoftheSunEast"}
locationTable["TransitionLocation: Sun R2"] = {"mapName": "temple_of_sun", "subMapXY": [4420, 1690], "locationName": "SunR2", "sectionName": "Vanilla Sun to Extinction Lower", "hostedItem": "TransitionSunR2", "isChild": True, "childOf": "Transition: Sun R2"}
locationTable["RuinDoor: Temple of the Sun [Main]"]= {"mapName": "temple_of_sun", "subMapXY": [2400,2100], "locationName": "Ruin Door(Sun)", "sectionName": "Vanilla Sun to Moon"}
locationTable["TransitionLocation: Sun Door"]={"mapName": "temple_of_sun", "subMapXY": [2400,2100], "locationName": "Ruin Door(Sun)", "sectionName": "Ruin Door(Sun)", "hostedItem": "DoorB3", "isChild": True, "childOf": "RuinDoor: Temple of the Sun [Main]"}

locationTable["Transition: Spring D1"] = {"mapName": "spring_in_the_sky", "subMapXY": [555, 2770], "locationName": "SpringD1", "sectionName": "Vanilla Spring to Guidance"}
locationTable["TransitionLocation: Spring D1"] = {"mapName": "spring_in_the_sky", "subMapXY": [555, 2770], "locationName": "SpringD1", "sectionName": "Vanilla Spring to Guidance", "hostedItem": "TransitionSpringD1", "isChild": True, "childOf": "Transition: Spring D1"}


locationTable["Transition: Inferno U1"] = {"mapName": "inferno_cavern", "subMapXY": [2640, 65], "locationName": "InfernoU1", "sectionName": "Vanilla Inferno to Twin"}
locationTable["TransitionLocation: Inferno U1"] = {"mapName": "inferno_cavern", "subMapXY": [2640, 65], "locationName": "InfernoU1", "sectionName": "Vanilla Inferno to Twin", "hostedItem": "TransitionInfernoU1", "isChild": True, "childOf": "Transition: Inferno U1"}
locationTable["Transition: Inferno U2"] = {"mapName": "inferno_cavern", "subMapXY": [1735, 65], "locationName": "InfernoU2", "sectionName": "Vanilla Inferno to Surface"}
locationTable["TransitionLocation: Inferno U2"] = {"mapName": "inferno_cavern", "subMapXY": [1735, 65], "locationName": "InfernoU2", "sectionName": "Vanilla Inferno to Surface", "hostedItem": "TransitionInfernoU2", "isChild": True, "childOf": "Transition: Inferno U2"}
locationTable["Transition: Inferno R1"] = {"mapName": "inferno_cavern", "subMapXY": [4425, 655], "locationName": "InfernoR1", "sectionName": "Vanilla Inferno to Sun"}
locationTable["TransitionLocation: Inferno R1"] = {"mapName": "inferno_cavern", "subMapXY": [4425, 655], "locationName": "InfernoR1", "sectionName": "Vanilla Inferno to Sun", "hostedItem": "TransitionInfernoR1", "isChild": True, "childOf": "Transition: Inferno R1"}
#This is One Way
#locationTable["Transition: Inferno W1"] = {"mapName": "inferno_cavern", "subMapXY": [2630, 2330], "locationName": "InfernoW1", "sectionName": "Vanilla Inferno Lava"}
locationTable["TransitionLocation: Inferno W1"] = {"mapName": "inferno_cavern", "subMapXY": [2630, 2330], "locationName": "InfernoW1", "sectionName": "Vanilla Inferno Lava", "hostedItem": "TransitionInfernoW1"}
locationTable["RuinDoor: Inferno Cavern [Spikes]"]= {"mapName": "inferno_cavern", "subMapXY": [715,95], "locationName": "Ruin Door(Spikes)", "sectionName": "Vanilla Inferno to Nuwa"}
locationTable["TransitionLocation: Echidna Door"]={"mapName": "inferno_cavern", "subMapXY": [715,95], "locationName": "Ruin Door(Spikes)", "sectionName": "Ruin Door(Spikes)", "hostedItem": "DoorB7", "isChild": True, "childOf": "RuinDoor: Inferno Cavern [Spikes]"}
locationTable["RuinDoor: Inferno Cavern [Viy]"]= {"mapName": "inferno_cavern", "subMapXY": [2075,2090], "locationName": "Ruin Door(Viy)", "sectionName": "Vanilla Viy"}
locationTable["TransitionLocation: Viy Door"]={"mapName": "inferno_cavern", "subMapXY": [2075,2090], "locationName": "Ruin Door(Viy)", "sectionName": "Ruin Door(Viy)", "hostedItem": "DoorB4", "isChild": True, "childOf": "RuinDoor: Inferno Cavern [Viy]"}

locationTable["Transition: Extinction L1"] = {"mapName": "chamber_of_extinction", "subMapXY": [45, 565], "locationName": "ExtinctionL1", "sectionName": "Vanilla Extinction to Sun Upper"}
locationTable["TransitionLocation: Extinction L1"] = {"mapName": "chamber_of_extinction", "subMapXY": [45, 565], "locationName": "ExtinctionL1", "sectionName": "Vanilla Extinction to Sun Upper", "hostedItem": "TransitionExtinctionL1", "isChild": True, "childOf": "Transition: Extinction L1"}
locationTable["Transition: Extinction L2"] = {"mapName": "chamber_of_extinction", "subMapXY": [45, 725], "locationName": "ExtinctionL2", "sectionName": "Vanilla Extinction to Sun Lower"}
locationTable["TransitionLocation: Extinction L2"] = {"mapName": "chamber_of_extinction", "subMapXY": [45, 725], "locationName": "ExtinctionL2", "sectionName": "Vanilla Extinction to Sun Lower", "hostedItem": "TransitionExtinctionL2", "isChild": True, "childOf": "Transition: Extinction L2"}
locationTable["Transition: Extinction U1"] = {"mapName": "chamber_of_extinction", "subMapXY": [4795, 2000], "locationName": "ExtinctionU1", "sectionName": "Vanilla Extinction to Shrine"}
locationTable["TransitionLocation: Extinction U1"] = {"mapName": "chamber_of_extinction", "subMapXY": [4795, 2000], "locationName": "ExtinctionU1", "sectionName": "Vanilla Extinction to Shrine", "hostedItem": "TransitionExtinctionU1", "isChild": True, "childOf": "Transition: Extinction U1"}
locationTable["Transition: Extinction U2"] = {"mapName": "chamber_of_extinction", "subMapXY": [3660, 65], "locationName": "ExtinctionU2", "sectionName": "Vanilla Extinction to Surface"}
locationTable["TransitionLocation: Extinction U2"] = {"mapName": "chamber_of_extinction", "subMapXY": [3660, 65], "locationName": "ExtinctionU2", "sectionName": "Vanilla Extinction to Surface", "hostedItem": "TransitionExtinctionU2", "isChild": True, "childOf": "Transition: Extinction U2"}
locationTable["Transition: Extinction U3"] = {"mapName": "chamber_of_extinction", "subMapXY": [4540, 540], "locationName": "ExtinctionU3", "sectionName": "Vanilla Extinction to Inferno"}
locationTable["TransitionLocation: Extinction U3"] = {"mapName": "chamber_of_extinction", "subMapXY": [4540, 540], "locationName": "ExtinctionU3", "sectionName": "Vanilla Extinction to Inferno", "hostedItem": "TransitionExtinctionU3", "isChild": True, "childOf": "Transition: Extinction U3"}
locationTable["RuinDoor: Chamber of Extinction [Magatama Left]"]= {"mapName": "chamber_of_extinction", "subMapXY": [1335,90], "locationName": "Ruin Door(Magatama)", "sectionName": "Vanilla Extinction to Birth"}
locationTable["TransitionLocation: Magatama Door"]={"mapName": "chamber_of_extinction", "subMapXY": [1335,90], "locationName": "Ruin Door(Magatama)", "sectionName": "Ruin Door(Magatama)", "hostedItem": "DoorB6", "isChild": True, "childOf": "RuinDoor: Chamber of Extinction [Magatama Left]"}
locationTable["RuinDoor: Chamber of Extinction [Main]"]= {"mapName": "chamber_of_extinction", "subMapXY": [4160,2000], "locationName": "Ruin Door(Extinction)", "sectionName": "Vanilla Extinction to Time"}
locationTable["TransitionLocation: Extinction Door"]={"mapName": "chamber_of_extinction", "subMapXY": [4160,2000], "locationName": "Ruin Door(Extinction)", "sectionName": "Ruin Door(Extinction)", "hostedItem": "DoorB9", "isChild": True, "childOf": "RuinDoor: Chamber of Extinction [Main]"}

locationTable["Transition: Twin U1"] = {"mapName": "twin_labyrinths", "subMapXY": [495, 560], "locationName": "TwinU1", "sectionName": "Vanilla Twin to Mausoleum"}
locationTable["TransitionLocation: Twin U1"] = {"mapName": "twin_labyrinths", "subMapXY": [495, 560], "locationName": "TwinU1", "sectionName": "Vanilla Twin to Mausoleum", "hostedItem": "TransitionTwinU1", "isChild": True, "childOf": "Transition: Twin U1"}
locationTable["Transition: Twin U2"] = {"mapName": "twin_labyrinths", "subMapXY": [4160, 45], "locationName": "TwinU2", "sectionName": "Vanilla Twin to Shrine"}
locationTable["TransitionLocation: Twin U2"] = {"mapName": "twin_labyrinths", "subMapXY": [4160, 45], "locationName": "TwinU2", "sectionName": "Vanilla Twin to Shrine", "hostedItem": "TransitionTwinU2", "isChild": True, "childOf": "Transition: Twin U2"}
locationTable["Transition: Twin U3"] = {"mapName": "twin_labyrinths", "subMapXY": [5255, 45], "locationName": "TwinU3", "sectionName": "Vanilla Twin to Dimensional","VisibleBeforeAvailable": "LocationTwinLabyrinthsPoseidon"}
locationTable["TransitionLocation: Twin U3"] = {"mapName": "twin_labyrinths", "subMapXY": [5255, 45], "locationName": "TwinU3", "sectionName": "Vanilla Twin to Dimensional", "hostedItem": "TransitionTwinU3", "isChild": True, "childOf": "Transition: Twin U3"}
locationTable["Transition: Twin D1"] = {"mapName": "twin_labyrinths", "subMapXY": [715, 2320], "locationName": "TwinD1", "sectionName": "Vanilla Twin to Inferno"}
locationTable["TransitionLocation: Twin D1"] = {"mapName": "twin_labyrinths", "subMapXY": [715, 2320], "locationName": "TwinD1", "sectionName": "Vanilla Twin to Inferno", "hostedItem": "TransitionTwinD1", "isChild": True, "childOf": "Transition: Twin D1"}
locationTable["Transition: Twin D2"] = {"mapName": "twin_labyrinths", "subMapXY": [5675, 2320], "locationName": "TwinD2", "sectionName": "Vanilla Twin to Moonlight"}
locationTable["TransitionLocation: Twin D2"] = {"mapName": "twin_labyrinths", "subMapXY": [5675, 2320], "locationName": "TwinD2", "sectionName": "Vanilla Twin to Moonlight", "hostedItem": "TransitionTwinD2", "isChild": True, "childOf": "Transition: Twin D2"}

locationTable["Transition: Endless U1"] = {"mapName": "endless_corridor", "subMapXY": [2975, 530], "locationName": "EndlessU1", "sectionName": "Vanilla Endless to Shrine Death Seal","VisibleBeforeAvailable": "LocationEndlessCorridor2F"}
locationTable["TransitionLocation: Endless U1"] = {"mapName": "endless_corridor", "subMapXY": [2975, 530], "locationName": "EndlessU1", "sectionName": "Vanilla Endless to Shrine Death Seal", "hostedItem": "TransitionEndlessU1", "isChild": True, "childOf": "Transition: Endless U1"}
locationTable["Transition: Endless R1"] = {"mapName": "endless_corridor", "subMapXY": [2530, 330], "locationName": "EndlessR1", "sectionName": "Vanilla Endless to Giants"}
locationTable["TransitionLocation: Endless R1"] = {"mapName": "endless_corridor", "subMapXY": [2530, 330], "locationName": "EndlessR1", "sectionName": "Vanilla Endless to Giants", "hostedItem": "TransitionEndlessR1", "isChild": True, "childOf": "Transition: Endless R1"}
locationTable["Transition: Endless D1"] = {"mapName": "endless_corridor", "subMapXY": [1080, 2325], "locationName": "EndlessD1", "sectionName": "Vanilla Endless to Shrine"}
locationTable["TransitionLocation: Endless D1"] = {"mapName": "endless_corridor", "subMapXY": [1080, 2325], "locationName": "EndlessD1", "sectionName": "Vanilla Endless to Shrine", "hostedItem": "TransitionEndlessD1", "isChild": True, "childOf": "Transition: Endless D1"}
#this is one way
#locationTable["RuinDoor: Endless Corridor [1F]"]= {"mapName": "endless_corridor", "subMapXY": [2335,240], "locationName": "Ruin Door(Endless)", "sectionName": "OopsEndless"}
locationTable["TransitionLocation: Endless Door"]={"mapName": "endless_corridor", "subMapXY": [2335,240], "locationName": "Ruin Door(Endless)", "sectionName": "Ruin Door(Endless)", "hostedItem": "DoorB8"}
locationTable["TransitionLocation: Endless L1"] = {"mapName": "endless_corridor", "subMapXY": [20, 330], "locationName": "EndlessL1", "sectionName": "One way to Somewhere", "hostedItem": "TransitionEndlessL1","VisibleBeforeAvailable": "LocationEndlessCorridor1F"}


locationTable["Transition: Shrine U1"] = {"mapName": "shrine_of_the_mother", "subMapXY": [1715, 65], "locationName": "ShrineU1", "sectionName": "Vanilla Shrine to Endless"}
locationTable["TransitionLocation: Shrine U1"] = {"mapName": "shrine_of_the_mother", "subMapXY": [1715, 65], "locationName": "ShrineU1", "sectionName": "Vanilla Shrine to Endless", "hostedItem": "TransitionShrineU1", "isChild": True, "childOf": "Transition: Shrine U1"}
locationTable["Transition: Shrine D1"] = {"mapName": "shrine_of_the_mother", "subMapXY": [2875, 2800], "locationName": "ShrineD1", "sectionName": "Vanilla Shrine to Extinction"}
locationTable["TransitionLocation: Shrine D1"] = {"mapName": "shrine_of_the_mother", "subMapXY": [2875, 2800], "locationName": "ShrineD1", "sectionName": "Vanilla Shrine to Extinction", "hostedItem": "TransitionShrineD1", "isChild": True, "childOf": "Transition: Shrine D1"}
locationTable["Transition: Shrine D2"] = {"mapName": "shrine_of_the_mother", "subMapXY": [3515, 1380], "locationName": "ShrineD2", "sectionName": "Vanilla Shrine Death Seal"}
locationTable["TransitionLocation: Shrine D2"] = {"mapName": "shrine_of_the_mother", "subMapXY": [3515, 1380], "locationName": "ShrineD2", "sectionName": "Vanilla Shrine Death Seal", "hostedItem": "TransitionShrineD2", "isChild": True, "childOf": "Transition: Shrine D2"}
locationTable["Transition: Shrine D3"] = {"mapName": "shrine_of_the_mother", "subMapXY": [315, 1380], "locationName": "ShrineD3", "sectionName": "Vanilla Shrine to Twin"}
locationTable["TransitionLocation: Shrine D3"] = {"mapName": "shrine_of_the_mother", "subMapXY": [315, 1380], "locationName": "ShrineD3", "sectionName": "Vanilla Shrine to Twin", "hostedItem": "TransitionShrineD3", "isChild": True, "childOf": "Transition: Shrine D3"}

locationTable["Transition: Illusion R1"] = {"mapName": "gate_of_illusion", "subMapXY": [3785, 650], "locationName": "IllusionR1", "sectionName": "Vanilla Illusion to Goddess"}
locationTable["TransitionLocation: Illusion R1"] = {"mapName": "gate_of_illusion", "subMapXY": [3785, 650], "locationName": "IllusionR1", "sectionName": "Vanilla Illusion to Goddess", "hostedItem": "TransitionIllusionR1", "isChild": True, "childOf": "Transition: Illusion R1"}
locationTable["Transition: Illusion R2"] = {"mapName": "gate_of_illusion", "subMapXY": [2510, 1370], "locationName": "IllusionR2", "sectionName": "Vanilla Illusion to Ruin"}
locationTable["TransitionLocation: Illusion R2"] = {"mapName": "gate_of_illusion", "subMapXY": [2510, 1370], "locationName": "IllusionR2", "sectionName": "Vanilla Illusion to Ruin", "hostedItem": "TransitionIllusionR2", "isChild": True, "childOf": "Transition: Illusion R2"}
locationTable["Transition: Illusion D1"] = {"mapName": "gate_of_illusion", "subMapXY": [1355, 2330], "locationName": "IllusionD1", "sectionName": "Vanilla Illusion to Graveyard"}
locationTable["TransitionLocation: Illusion D1"] = {"mapName": "gate_of_illusion", "subMapXY": [1355, 2330], "locationName": "IllusionD1", "sectionName": "Vanilla Illusion to Graveyard", "hostedItem": "TransitionIllusionD1", "isChild": True, "childOf": "Transition: Illusion D1"}
locationTable["Transition: Illusion D2"] = {"mapName": "gate_of_illusion", "subMapXY": [3975, 2810], "locationName": "IllusionD2", "sectionName": "Vanilla Illusion to Moonlight"}
locationTable["TransitionLocation: Illusion D2"] = {"mapName": "gate_of_illusion", "subMapXY": [3975, 2810], "locationName": "IllusionD2", "sectionName": "Vanilla Illusion to Moonlight", "hostedItem": "TransitionIllusionD2", "isChild": True, "childOf": "Transition: Illusion D2"}
locationTable["RuinDoor: Gate of Illusion [Grail]"]= {"mapName": "gate_of_illusion", "subMapXY": [1340,540], "locationName": "Ruin Door(Illusion)", "sectionName": "Vanilla Illusion to Guidance"}
locationTable["TransitionLocation: Illusion Door"]={"mapName": "gate_of_illusion", "subMapXY": [1340,540], "locationName": "Ruin Door(Illusion)", "sectionName": "Ruin Door(Illusion)", "hostedItem": "DoorF1", "isChild": True, "childOf": "RuinDoor: Gate of Illusion [Grail]"}


locationTable["Transition: Graveyard L1"] = {"mapName": "graveyard_of_giants", "subMapXY": [655, 2100], "locationName": "GraveyardL1", "sectionName": "Vanilla Graveyard to Ruin"}
locationTable["TransitionLocation: Graveyard L1"] = {"mapName": "graveyard_of_giants", "subMapXY": [655, 2100], "locationName": "GraveyardL1", "sectionName": "Vanilla Graveyard to Ruin", "hostedItem": "TransitionGraveyardL1", "isChild": True, "childOf": "Transition: Graveyard L1"}
locationTable["Transition: Graveyard U1"] = {"mapName": "graveyard_of_giants", "subMapXY": [710, 65], "locationName": "GraveyardU1", "sectionName": "Vanilla Graveyard to Illusion"}
locationTable["TransitionLocation: Graveyard U1"] = {"mapName": "graveyard_of_giants", "subMapXY": [710, 65], "locationName": "GraveyardU1", "sectionName": "Vanilla Graveyard to Illusion", "hostedItem": "TransitionGraveyardU1", "isChild": True, "childOf": "Transition: Graveyard U1"}
locationTable["Transition: Graveyard U2"] = {"mapName": "graveyard_of_giants", "subMapXY": [4395, 1490], "locationName": "GraveyardU2", "sectionName": "Vanilla Graveyard to Goddess"}
locationTable["TransitionLocation: Graveyard U2"] = {"mapName": "graveyard_of_giants", "subMapXY": [4395, 1490], "locationName": "GraveyardU2", "sectionName": "Vanilla Graveyard to Goddess", "hostedItem": "TransitionGraveyardU2", "isChild": True, "childOf": "Transition: Graveyard U2"}
locationTable["Transition: Graveyard R1"] = {"mapName": "graveyard_of_giants", "subMapXY": [2500, 735], "locationName": "GraveyardR1", "sectionName": "Vanilla Graveyard to Moonlight"}
locationTable["TransitionLocation: Graveyard R1"] = {"mapName": "graveyard_of_giants", "subMapXY": [2500, 735], "locationName": "GraveyardR1", "sectionName": "Vanilla Graveyard to Moonlight", "hostedItem": "TransitionGraveyardR1", "isChild": True, "childOf": "Transition: Graveyard R1"}
locationTable["Transition: Graveyard D1"] = {"mapName": "graveyard_of_giants", "subMapXY": [3075, 2340], "locationName": "GraveyardD1", "sectionName": "Vanilla Graveyard to Birth"}
locationTable["TransitionLocation: Graveyard D1"] = {"mapName": "graveyard_of_giants", "subMapXY": [3075, 2340], "locationName": "GraveyardD1", "sectionName": "Vanilla Graveyard to Birth", "hostedItem": "TransitionGraveyardD1", "isChild": True, "childOf": "Transition: Graveyard D1"}
locationTable["RuinDoor: Graveyard of the Giants [West]"]= {"mapName": "graveyard_of_giants", "subMapXY": [1375,1135], "locationName": "Ruin Door(Graveyard)", "sectionName": "Vanilla Graveyard to Mausoleum"}
locationTable["TransitionLocation: Graveyard Door"]={"mapName": "graveyard_of_giants", "subMapXY": [1375,1135], "locationName": "Ruin Door(Graveyard)", "sectionName": "Ruin Door(Graveyard)", "hostedItem": "DoorF2", "isChild": True, "childOf": "RuinDoor: Graveyard of the Giants [West]"}

locationTable["Transition: Moonlight L1"] = {"mapName": "temple_of_moonlight", "subMapXY": [675, 2165], "locationName": "MoonlightL1", "sectionName": "Vanilla Moonlight to Graveyard","VisibleBeforeAvailable": "LocationTempleofMoonlightLower"}
locationTable["TransitionLocation: Moonlight L1"] = {"mapName": "temple_of_moonlight", "subMapXY": [675, 2165], "locationName": "MoonlightL1", "sectionName": "Vanilla Moonlight to Graveyard", "hostedItem": "TransitionMoonlightL1", "isChild": True, "childOf": "Transition: Moonlight L1"}
locationTable["Transition: Moonlight U1"] = {"mapName": "temple_of_moonlight", "subMapXY": [775, 55], "locationName": "MoonlightU1", "sectionName": "Vanilla Moonlight to Illusion"}
locationTable["TransitionLocation: Moonlight U1"] = {"mapName": "temple_of_moonlight", "subMapXY": [775, 55], "locationName": "MoonlightU1", "sectionName": "Vanilla Moonlight to Illusion", "hostedItem": "TransitionMoonlightU1", "isChild": True, "childOf": "Transition: Moonlight U1"}
locationTable["Transition: Moonlight U2"] = {"mapName": "temple_of_moonlight", "subMapXY": [2475, 525], "locationName": "MoonlightU2", "sectionName": "Vanilla Moonlight to Twin"}
locationTable["TransitionLocation: Moonlight U2"] = {"mapName": "temple_of_moonlight", "subMapXY": [2475, 525], "locationName": "MoonlightU2", "sectionName": "Vanilla Moonlight to Twin", "hostedItem": "TransitionMoonlightU2", "isChild": True, "childOf": "Transition: Moonlight U2"}
locationTable["RuinDoor: Temple of Moonlight [Lower]"]= {"mapName": "temple_of_moonlight", "subMapXY": [1500,2175], "locationName": "Ruin Door(Moonlight)", "sectionName": "Vanilla Moonlight to Sun"}
locationTable["TransitionLocation: Moonlight Door"]={"mapName": "temple_of_moonlight", "subMapXY": [1500,2175], "locationName": "Ruin Door(Moonlight)", "sectionName": "Ruin Door(Moonlight)", "hostedItem": "DoorF3", "isChild": True, "childOf": "RuinDoor: Temple of Moonlight [Lower]"}

locationTable["Transition: Goddess L1"] = {"mapName": "tower_of_the_goddess", "subMapXY": [1325, 170], "locationName": "GoddessL1", "sectionName": "Vanilla Goddess to Illusion","VisibleBeforeAvailable": "LocationToweroftheGoddessSpaulder"}
locationTable["TransitionLocation: Goddess L1"] = {"mapName": "tower_of_the_goddess", "subMapXY": [1325, 170], "locationName": "GoddessL1", "sectionName": "Vanilla Goddess to Illusion", "hostedItem": "TransitionGoddessL1", "isChild": True, "childOf": "Transition: Goddess L1"}
locationTable["Transition: Goddess L2"] = {"mapName": "tower_of_the_goddess", "subMapXY": [685, 3210], "locationName": "GoddessL2", "sectionName": "Vanilla Goddess to Ruin","VisibleBeforeAvailable": "LocationToweroftheGoddessLower"}
locationTable["TransitionLocation: Goddess L2"] = {"mapName": "tower_of_the_goddess", "subMapXY": [685, 3210], "locationName": "GoddessL2", "sectionName": "Vanilla Goddess to Ruin", "hostedItem": "TransitionGoddessL2", "isChild": True, "childOf": "Transition: Goddess L2"}
locationTable["Transition: Goddess U1"] = {"mapName": "tower_of_the_goddess", "subMapXY": [95, 535], "locationName": "GoddessU1", "sectionName": "Vanilla Goddess to Birth","VisibleBeforeAvailable": "LocationToweroftheGoddessLamp"}
locationTable["TransitionLocation: Goddess U1"] = {"mapName": "tower_of_the_goddess", "subMapXY": [95, 535], "locationName": "GoddessU1", "sectionName": "Vanilla Goddess to Birth", "hostedItem": "TransitionGoddessU1", "isChild": True, "childOf": "Transition: Goddess U1"}
locationTable["Transition: Goddess D1"] = {"mapName": "tower_of_the_goddess", "subMapXY": [3110, 425], "locationName": "GoddessD1", "sectionName": "Vanilla Goddess to Graveyard"}
locationTable["TransitionLocation: Goddess D1"] = {"mapName": "tower_of_the_goddess", "subMapXY": [3110, 425], "locationName": "GoddessD1", "sectionName": "Vanilla Goddess to Graveyard", "hostedItem": "TransitionGoddessD1", "isChild": True, "childOf": "Transition: Goddess D1"}
#This is one way
#locationTable["Transition: Goddess W1"] = {"mapName": "tower_of_the_goddess", "subMapXY": [560, 550], "locationName": "GoddessW1", "sectionName": "Vanilla Goddess Warp landing"}
locationTable["TransitionLocation: Goddess W1"] = {"mapName": "tower_of_the_goddess", "subMapXY": [560, 550], "locationName": "GoddessW1", "sectionName": "Vanilla Goddess Warp landing", "hostedItem": "TransitionGoddessW1"}
locationTable["RuinDoor: Tower of the Goddess [Lower]"]= {"mapName": "tower_of_the_goddess", "subMapXY": [960,4240], "locationName": "Ruin Door(Goddess)", "sectionName": "Vanilla Goddess to Surface"}
locationTable["TransitionLocation: Goddess Door"]={"mapName": "tower_of_the_goddess", "subMapXY": [960,4240], "locationName": "Ruin Door(Goddess)", "sectionName": "Ruin Door(Goddess)", "hostedItem": "DoorF5", "isChild": True, "childOf": "RuinDoor: Tower of the Goddess [Lower]"}

locationTable["Transition: Ruin L1"] = {"mapName": "tower_of_ruin", "subMapXY": [40, 1365], "locationName": "RuinL1", "sectionName": "Vanilla Ruin to Illusion"}
locationTable["TransitionLocation: Ruin L1"] = {"mapName": "tower_of_ruin", "subMapXY": [40, 1365], "locationName": "RuinL1", "sectionName": "Vanilla Ruin to Illusion", "hostedItem": "TransitionRuinL1", "isChild": True, "childOf": "Transition: Ruin L1"}
locationTable["Transition: Ruin R1"] = {"mapName": "tower_of_ruin", "subMapXY": [4435, 810], "locationName": "RuinR1", "sectionName": "Vanilla Ruin to Goddess"}
locationTable["TransitionLocation: Ruin R1"] = {"mapName": "tower_of_ruin", "subMapXY": [4435, 810], "locationName": "RuinR1", "sectionName": "Vanilla Ruin to Goddess", "hostedItem": "TransitionRuinR1", "isChild": True, "childOf": "Transition: Ruin R1"}
locationTable["Transition: Ruin R2"] = {"mapName": "tower_of_ruin", "subMapXY": [4435, 2090], "locationName": "RuinR2", "sectionName": "Vanilla Ruin to Graveyard"}
locationTable["TransitionLocation: Ruin R2"] = {"mapName": "tower_of_ruin", "subMapXY": [4435, 2090], "locationName": "RuinR2", "sectionName": "Vanilla Ruin to Graveyard", "hostedItem": "TransitionRuinR2", "isChild": True, "childOf": "Transition: Ruin R2"}
locationTable["RuinDoor: Tower of Ruin [Southwest Door]"]= {"mapName": "tower_of_ruin", "subMapXY": [2240,2660], "locationName": "Ruin Door(Babel)", "sectionName": "Vanilla Ruin to Viy"}
locationTable["TransitionLocation: Babel Door"]={"mapName": "tower_of_ruin", "subMapXY": [2240,2660], "locationName": "Ruin Door(Babel)", "sectionName": "Ruin Door(Babel)", "hostedItem": "DoorF4", "isChild": True, "childOf": "RuinDoor: Tower of Ruin [Southwest Door]"}
locationTable["RuinDoor: Tower of Ruin [Top]"]= {"mapName": "tower_of_ruin", "subMapXY": [3520,135], "locationName": "Ruin Door(Nuwa)", "sectionName": "Vanilla Inferno to Nuwa"}
locationTable["TransitionLocation: Nuwa Door"]={"mapName": "tower_of_ruin", "subMapXY": [3520,135], "locationName": "Ruin Door(Nuwa)", "sectionName": "Ruin Door(Nuwa)", "hostedItem": "DoorF7", "isChild": True, "childOf": "RuinDoor: Tower of Ruin [Top]"}

locationTable["Transition: Birth L1"] = {"mapName": "chamber_of_birth", "subMapXY": [4525, 1765], "locationName": "BirthL1", "sectionName": "Vanilla Birth Woman to Skanda"}
locationTable["TransitionLocation: Birth L1"] = {"mapName": "chamber_of_birth", "subMapXY": [4525, 1765], "locationName": "BirthL1", "sectionName": "Vanilla Birth Woman to Skanda", "hostedItem": "TransitionBirthL1", "isChild": True, "childOf": "Transition: Birth L1"}
locationTable["Transition: Birth U1"] = {"mapName": "chamber_of_birth", "subMapXY": [2435, 40], "locationName": "BirthU1", "sectionName": "Vanilla Birth to Graveyard"}
locationTable["TransitionLocation: Birth U1"] = {"mapName": "chamber_of_birth", "subMapXY": [2435, 40], "locationName": "BirthU1", "sectionName": "Vanilla Birth to Graveyard", "hostedItem": "TransitionBirthU1", "isChild": True, "childOf": "Transition: Birth U1"}
locationTable["Transition: Birth R1"] = {"mapName": "chamber_of_birth", "subMapXY": [3800, 2255], "locationName": "BirthR1", "sectionName": "Vanilla Birth Skanda to Woman"}
locationTable["TransitionLocation: Birth R1"] = {"mapName": "chamber_of_birth", "subMapXY": [3800, 2255], "locationName": "BirthR1", "sectionName": "Vanilla Birth Skanda to Woman", "hostedItem": "TransitionBirthR1", "isChild": True, "childOf": "Transition: Birth R1"}
locationTable["Transition: Birth D1"] = {"mapName": "chamber_of_birth", "subMapXY": [95, 1370], "locationName": "BirthD1", "sectionName": "Vanilla Birth to Goddess"}
locationTable["TransitionLocation: Birth D1"] = {"mapName": "chamber_of_birth", "subMapXY": [95, 1370], "locationName": "BirthD1", "sectionName": "Vanilla Birth to Goddess", "hostedItem": "TransitionBirthD1", "isChild": True, "childOf": "Transition: Birth D1"}
locationTable["RuinDoor: Chamber of Birth [Northeast]"]= {"mapName": "chamber_of_birth", "subMapXY": [2240,900], "locationName": "Ruin Door(Birth)", "sectionName": "Vanilla Birth to Extinction"}
locationTable["TransitionLocation: Birth Door"]={"mapName": "chamber_of_birth", "subMapXY": [2240,900], "locationName": "Ruin Door(Birth)", "sectionName": "Ruin Door(Birth)", "hostedItem": "DoorF6", "isChild": True, "childOf": "RuinDoor: Chamber of Birth [Northeast]"}

locationTable["Transition: Dimensional D1"] = {"mapName": "dimensional_corridor", "subMapXY": [730, 3330], "locationName": "DimensionalD1", "sectionName": "Vanilla Dimensional to Twin"}
locationTable["TransitionLocation: Dimensional D1"] = {"mapName": "dimensional_corridor", "subMapXY": [730, 3330], "locationName": "DimensionalD1", "sectionName": "Vanilla Dimensional to Twin", "hostedItem": "TransitionDimensionalD1", "isChild": True, "childOf": "Transition: Dimensional D1"}
locationTable["RuinDoor: Dimensional Corridor [Grail]"]= {"mapName": "dimensional_corridor", "subMapXY": [950,2725], "locationName": "Ruin Door(Dimensional)", "sectionName": "Vanilla Dimensional to Endless"}
locationTable["TransitionLocation: Dimensional Door"]={"mapName": "dimensional_corridor", "subMapXY": [950,2725], "locationName": "Ruin Door(Dimensional)", "sectionName": "Ruin Door(Dimensional)", "hostedItem": "DoorF8", "isChild": True, "childOf": "RuinDoor: Dimensional Corridor [Grail]"}

locationTable["RuinDoor: Gate of Time [Mausoleum Lower]"]= {"mapName": "gate_of_time", "subMapXY": [2235,5135], "locationName": "Ruin Door(Time)", "sectionName": "Vanilla Time to Extinction"}
locationTable["TransitionLocation: Time Door"]={"mapName": "gate_of_time", "subMapXY": [2235,5135], "locationName": "Ruin Door(Time)", "sectionName": "Ruin Door(Time)", "hostedItem": "DoorF9", "isChild": True, "childOf": "RuinDoor: Gate of Time [Mausoleum Lower]"}

locationTable["Transition: Retromausoleum D1"] = {"mapName": "gate_of_time", "subMapXY": [4330, 4730], "locationName": "RetromausoleumD1", "sectionName": "Vanilla Retromausoleum to Goddess"}
locationTable["TransitionLocation: Retromausoleum D1"] = {"mapName": "gate_of_time", "subMapXY": [4330, 4730], "locationName": "RetromausoleumD1", "sectionName": "Vanilla Retromausoleum to Goddess", "hostedItem": "TransitionRetromausoleumD1", "isChild": True, "childOf": "Transition: Retromausoleum D1"}
locationTable["Transition: Retromausoleum U1"] = {"mapName": "gate_of_time", "subMapXY": [75, 2945], "locationName": "RetromausoleumU1", "sectionName": "Vanilla Retromausoleum to Retroguidance"}
locationTable["TransitionLocation: Retromausoleum U1"] = {"mapName": "gate_of_time", "subMapXY": [75, 2945], "locationName": "RetromausoleumU1", "sectionName": "Vanilla Retromausoleum to Retroguidance", "hostedItem": "TransitionRetromausoleumU1", "isChild": True, "childOf": "Transition: Retromausoleum U1"}
locationTable["Transition: Retroguidance D1"] = {"mapName": "gate_of_time", "subMapXY": [75, 2800], "locationName": "RetroguidanceD1", "sectionName": "Vanilla Retroguidance to Retromausoleum"}
locationTable["TransitionLocation: Retroguidance D1"] = {"mapName": "gate_of_time", "subMapXY": [75, 2800], "locationName": "RetroguidanceD1", "sectionName": "Vanilla Retroguidance to Retromausoleum", "hostedItem": "TransitionRetroguidanceD1", "isChild": True, "childOf": "Transition: Retroguidance D1"}
locationTable["Transition: Retroguidance L1"] = {"mapName": "gate_of_time", "subMapXY": [1375, 315], "locationName": "RetroguidanceL1", "sectionName": "Vanilla Retroguidance to Retrosurface"}
locationTable["TransitionLocation: Retroguidance L1"] = {"mapName": "gate_of_time", "subMapXY": [1375, 315], "locationName": "RetroguidanceL1", "sectionName": "Vanilla Retroguidance to Retrosurface", "hostedItem": "TransitionRetroguidanceL1", "isChild": True, "childOf": "Transition: Retroguidance L1"}
locationTable["Transition: Retrosurface R1"] = {"mapName": "gate_of_time", "subMapXY": [1180, 315], "locationName": "RetrosurfaceR1", "sectionName": "Vanilla Retrosurface to Retroguidance"}
locationTable["TransitionLocation: Retrosurface R1"] = {"mapName": "gate_of_time", "subMapXY": [1180, 315], "locationName": "RetrosurfaceR1", "sectionName": "Vanilla Retrosurface to Retroguidance", "hostedItem": "TransitionRetrosurfaceR1", "isChild": True, "childOf": "Transition: Retrosurface R1"}

#locationTable["Location: Hell Temple [Entrance]"]={"mapName": "hell_temple", "subMapXY": [1445,1520], "locationName": "Hell_Entrance", "sectionName": "Hell_Entrance", "hostedItem": "LocationHellTempleEntrance"}

#NPC Doors, sharing same cooridnate as shops if applicable
#NPC Doors, sharing same cooridnate as shops if applicable
locationTable["NPCL: Modro"] = {"mapName": "surface", "subMapXY": [4360, 1700], "locationName": "Modro's Shop", "sectionName": "NPC door"}
locationTable["NPCL: Nebur"] = {"mapName": "surface", "subMapXY": [3580, 1620], "locationName": "Nebur's shop", "sectionName": "NPC door"}
locationTable["NPCL: Sidro"] = {"mapName": "surface", "subMapXY": [4100, 1780], "locationName": "Sidro's Shop", "sectionName": "NPC door"}
locationTable["NPCL: Elder Xelpud "] = {"mapName": "surface", "subMapXY": [4040, 1620], "locationName": "Xelpud's Tent", "sectionName": "NPC door"}
locationTable["NPCL: Hiner"] = {"mapName": "surface", "subMapXY": [1800, 1140], "locationName": "Hiner's Tent", "sectionName": "NPC door"}
locationTable["NPCL: Moger"] = {"mapName": "surface", "subMapXY": [3440, 1780], "locationName": "Moger's Tent", "sectionName": "NPC door"}
locationTable["NPCL: Former Mekuri Master"] = {"mapName": "surface", "subMapXY": [6760, 820], "locationName": "Mekuri Master's Tent", "sectionName": "NPC door"}

locationTable["NPCL: Priest Zarnac"] = {"mapName": "gate_of_guidance", "subMapXY": [700, 1545], "locationName": "Priest Zarnac", "sectionName": "NPC door"}
locationTable["NPCL: Penadvent of ghost"] = {"mapName": "gate_of_guidance", "subMapXY": [858, 2662], "locationName": "Penadvent of ghost shop", "sectionName": "NPC door"}

locationTable["NPCL: Priest Xanado"] = {"mapName": "mausoleum_of_giants", "subMapXY": [1980, 105], "locationName": "Priest Xanado", "sectionName": "NPC door"}
locationTable["NPCL: Greedy Charlie"] = {"mapName": "mausoleum_of_giants", "subMapXY": [3478, 1305], "locationName": "Greedy Charlie's shop", "sectionName": "NPC door"}

locationTable["NPCL: Shalom III"] = {"mapName": "temple_of_sun", "subMapXY": [2180, 815], "locationName": "Shalom III's shop", "sectionName": "NPC door"}
locationTable["NPCL: Kingvalley I"] = {"mapName": "temple_of_sun", "subMapXY": [1080, 2100], "locationName": "Kingvalley I's shop", "sectionName": "NPC door"}
locationTable["NPCL: Usas VI"] = {"mapName": "temple_of_sun", "subMapXY": [2758, 2335], "locationName": "Usas VI's shop", "sectionName": "NPC door"}
locationTable["NPCL: Priest Madomono"] = {"mapName": "temple_of_sun", "subMapXY": [3700, 1055], "locationName": "Priest Madomono", "sectionName": "NPC door"}

locationTable["NPCL: Mr. Fishman (Original)"] = {"mapName": "spring_in_the_sky", "subMapXY": [2517, 1620], "locationName": "Gyonin's Shop", "sectionName": "NPC door"}
locationTable["NPCL: Mr. Fishman (Alt)"] = {"mapName": "spring_in_the_sky", "subMapXY": [2120, 1520], "locationName": "Gyonin's Shop", "sectionName": "Secret NPC door"}
locationTable["NPCL: Philosopher Giltoriyo"] = {"mapName": "spring_in_the_sky", "subMapXY": [60, 2265], "locationName": "Philosopher Giltoriyo", "sectionName": "NPC door"}
locationTable["NPCL: Priest Hidlyda"] = {"mapName": "spring_in_the_sky", "subMapXY": [960, 3545], "locationName": "Priest Hidlyda", "sectionName": "NPC door"}

locationTable["NPCL: Hot-blooded Nemesistwo"] = {"mapName": "inferno_cavern", "subMapXY": [2680, 1540], "locationName": "Nemesistwo's shop", "sectionName": "NPC door"}
locationTable["NPCL: Priest Gailious"] = {"mapName": "inferno_cavern", "subMapXY": [2342, 1220], "locationName": "Priest Gailious", "sectionName": "NPC door"}
locationTable["NPCL: Priest Romancis"] = {"mapName": "inferno_cavern", "subMapXY": [1480, 1380], "locationName": "Priest Romancis", "sectionName": "NPC door"}

locationTable["NPCL: Operator Combaker"] = {"mapName": "chamber_of_extinction", "subMapXY": [4776, 740], "locationName": "Combaker's shop", "sectionName": "NPC door"}
locationTable["NPCL: Priest Triton"] = {"mapName": "chamber_of_extinction", "subMapXY": [5180, 1060], "locationName": "Priest Triton", "sectionName": "NPC door"}
locationTable["NPCL: Priest Aramo"] = {"mapName": "chamber_of_extinction", "subMapXY": [3340, 1540], "locationName": "Priest Aramo", "sectionName": "NPC door"}

locationTable["NPCL: Yiear Kungfu"] = {"mapName": "twin_labyrinths", "subMapXY": [6078, 1535], "locationName": "Big Brother's shop", "sectionName": "NPC door"}
locationTable["NPCL: Yiegah Kungfu"] = {"mapName": "twin_labyrinths", "subMapXY": [318, 1535], "locationName": "Little Brother's shop", "sectionName": "NPC door"}
locationTable["NPCL: Arrogant Metagear"] = {"mapName": "twin_labyrinths", "subMapXY": [2498, 1535], "locationName": "Metagear's shop", "sectionName": "NPC door"}
locationTable["NPCL: Arrogant Sturdy Snake"] = {"mapName": "twin_labyrinths", "subMapXY": [3900, 1535], "locationName": "Sturdy Snake's shop", "sectionName": "NPC door"}
locationTable["NPCL: Priest Jaguarfiv"] = {"mapName": "twin_labyrinths", "subMapXY": [5438, 340], "locationName": "Priest Jaguarfiv", "sectionName": "NPC door"}

locationTable["NPCL: Affected Knimare"] = {"mapName": "endless_corridor", "subMapXY": [1500, 340], "locationName": "Knimare's shop", "sectionName": "NPC door"}
locationTable["NPCL: The Fairy Queen"] = {"mapName": "endless_corridor", "subMapXY": [58, 180], "locationName": "The Fairy Queen", "sectionName": "NPC door"}

locationTable["NPCL: Mover Athleland"] = {"mapName": "gate_of_illusion", "subMapXY": [580, 1225], "locationName": "Mover Athleland's shop", "sectionName": "NPC door"}
locationTable["NPCL: duplex"] = {"mapName": "gate_of_illusion", "subMapXY": [2302, 1545], "locationName": "Dev duplex", "sectionName": "NPC door"}
locationTable["NPCL: Mr. Slushfund"] = {"mapName": "gate_of_illusion", "subMapXY": [3258, 1545], "locationName": "Mr. Slushfund", "sectionName": "NPC door"}
locationTable["NPCL: Priest Alest"] = {"mapName": "gate_of_illusion", "subMapXY": [3700, 2025], "locationName": "Priest Alest", "sectionName": "NPC door"}

locationTable["NPCL: Giant Mopiran"] = {"mapName": "graveyard_of_giants", "subMapXY": [120, 420], "locationName": "Giant Mopiran's shop", "sectionName": "NPC door"}
locationTable["NPCL: Giant Thexde"] = {"mapName": "graveyard_of_giants", "subMapXY": [2682, 1540], "locationName": "Giant Thexde", "sectionName": "NPC door"}

locationTable["NPCL: Kingvalley II"] = {"mapName": "temple_of_moonlight", "subMapXY": [3758, 1535], "locationName": "Kingvalley II's shop", "sectionName": "NPC door"}
locationTable["NPCL: Samieru"] = {"mapName": "temple_of_moonlight", "subMapXY": [698, 1295], "locationName": "Dev Samieru", "sectionName": "NPC door"}
locationTable["NPCL: Philosopher Alsedana"] = {"mapName": "temple_of_moonlight", "subMapXY": [2760, 1055], "locationName": "Philosopher Alsedana", "sectionName": "NPC door"}

locationTable["NPCL: Energetic Belmont"] = {"mapName": "tower_of_the_goddess", "subMapXY": [378, 1380], "locationName": "Energetic Belmont's shop", "sectionName": "NPC door"}
locationTable["NPCL: Naramura"] = {"mapName": "tower_of_the_goddess", "subMapXY": [2485, 2280], "locationName": "Dev Naramura", "sectionName": "NPC door"}
locationTable["NPCL: Philosopher Samaranta"] = {"mapName": "tower_of_the_goddess", "subMapXY": [1840, 2100], "locationName": "Philosopher Samaranta", "sectionName": "NPC door"}

locationTable["NPCL: Mechanical Efspi"] = {"mapName": "tower_of_ruin", "subMapXY": [1600, 1060], "locationName": "Efspi's shop", "sectionName": "NPC door"}
locationTable["NPCL: Priest Laydoc"] = {"mapName": "tower_of_ruin", "subMapXY": [3260, 2020], "locationName": "Priest Laydoc", "sectionName": "NPC door"}

locationTable["NPCL: Mud Man Qubert"] = {"mapName": "chamber_of_birth", "subMapXY": [1357, 1780], "locationName": "Mud Man Qubert's shop", "sectionName": "NPC door"}
locationTable["NPCL: Priest Ashgine"] = {"mapName": "chamber_of_birth", "subMapXY": [700, 1700], "locationName": "Priest Ashgine", "sectionName": "NPC door"}

locationTable["NPCL: Philosopher Fobos"] = {"mapName": "dimensional_corridor", "subMapXY": [320, 2100], "locationName": "Philosopher Fobos", "sectionName": "NPC door"}
locationTable["NPCL: 8bit Elder"] = {"mapName": "gate_of_time", "subMapXY": [200, 180], "locationName": "8bit Elder", "sectionName": "NPC door"}
locationTable["NPCL: Tailor Dracuet"] = {"mapName": "hell_temple", "subMapXY": [1836, 2000], "locationName": "Draucet's Shop", "sectionName": "NPC door"}

locationTranslation = {}
locationTranslation["surface"] = [0, 636, 0.11380208333]
locationTranslation["gate_of_guidance"] = [0, 0, 0.09754464285]
locationTranslation["gate_of_illusion"] = [437, 0, 0.09754464285]
locationTranslation["mausoleum_of_giants"] = [874, 17, 0.0853515625]
locationTranslation["graveyard_of_giants"] = [1311, 0, 0.09754464285]
locationTranslation["temple_of_sun"] = [0, 304, 0.09754464285]
locationTranslation["temple_of_moonlight"] = [437, 282, 0.11380208333]
locationTranslation["spring_in_the_sky"] = [3088, 0, 0.0978125]
locationTranslation["tower_of_the_goddess"] = [3468, 0, 0.1084375]
locationTranslation["chamber_of_extinction"] = [1748, 0, 0.11701388888]
locationTranslation["chamber_of_birth"] = [1757, 281, 0.11371527777]
locationTranslation["inferno_cavern"] = [873, 304, 0.09754464285]
locationTranslation["tower_of_ruin"] = [1311, 304, 0.09754464285]
locationTranslation["endless_corridor"] = [2422, 0, 0.195]
locationTranslation["dimensional_corridor"] = [2555, 468, 0.139453125]
locationTranslation["twin_labyrinths"] = [933, 609, 0.1365625]
locationTranslation["shrine_of_the_mother"] = [1866, 608, 0.11380208333]
locationTranslation["gate_of_time"] = [3046, 468, 0.08883928571]
locationTranslation["hell_temple"] = [3499, 468, 0.0890625]

def parseLogic(someRuleList, masterList):
	for itemEntry in someRuleList:
		itemEntry = re.sub("#.*", "", itemEntry)
		if len(itemEntry) > 1:
			firstSplit = itemEntry.split("=>")
			requirements = []
			for requirement in firstSplit[1].split(","):
				requirements.append(requirement.strip())
			if not masterList.get(firstSplit[0].strip()):
				masterList[firstSplit[0].strip()] = []
			masterList[firstSplit[0].strip()].append(requirements)
	return masterList



def buildMasterList():
	listOfFiles = ["location_reqs.txt", "item_reqs.txt", "event_reqs.txt", "shop_reqs.txt", "attack_reqs.txt", "dead_ends.txt", "transition_reqs.txt", "glitch_reqs.txt", "coin_chest_reqs.txt", "trap_item_reqs.txt", "bosses/medium_reqs.txt","npc_door_reqs.txt"]
	masterList = {}
	for someFile in listOfFiles:
		someDownloadedFile = requests.get("https://raw.githubusercontent.com/thezerothcat/LaMulanaRandomizer/master/src/main/resources/lmr/randomizer/requirement/" + someFile).text.splitlines()
		masterList = parseLogic(someDownloadedFile, masterList)
	localFiles = ["seal_logic.txt","npc_logic.txt","other_logic.txt"]
	for someFile in localFiles:
		f=open("./logic/"+someFile, "r")
		someDownloadedFile = f.read().splitlines()
		masterList = parseLogic(someDownloadedFile, masterList)
		f.close()
	return masterList


listOfItems = []
listofNodes=[]
listOfGuardians=["Amphisbaena", "Sakit", "Ellmac", "Bahamut", "Viy", "Palenque", "Baphomet", "Tiamat"]
listofItemizeLocations=["Location: Surface [Main]","Location: Surface [Ruin Path Upper]","Location: Surface [Ruin Path Lower]","Location: Gate of Guidance [Main]","Location: Gate of Guidance [Door]","Location: Gate of Illusion [Eden]","Location: Gate of Illusion [Lower]","Location: Gate of Illusion [Grail]","Location: Gate of Illusion [Ruin]","Location: Gate of Illusion [Pot Room]","Location: Mausoleum of the Giants","Location: Graveyard of the Giants [West]","Location: Graveyard of the Giants [Grail]","Location: Graveyard of the Giants [East]","Location: Temple of the Sun [Top Entrance]","Location: Temple of the Sun [Main]","Location: Temple of the Sun [West]","Location: Temple of the Sun [East]","Location: Temple of Moonlight [Upper]","Location: Temple of Moonlight [Lower]","Location: Temple of Moonlight [Eden]","Location: Spring in the Sky [Main]","Location: Tower of the Goddess [Lower]","Location: Tower of the Goddess [Lamp]","Location: Tower of the Goddess [Spaulder]","Location: Tower of the Goddess [Shield Statue]","Location: Inferno Cavern [Main]","Location: Inferno Cavern [Lava]","Location: Inferno Cavern [Viy]","Location: Inferno Cavern [Spikes]","Location: Tower of Ruin [Southeast]","Location: Tower of Ruin [Southwest Door]","Location: Tower of Ruin [Illusion]","Location: Tower of Ruin [Medicine]","Location: Tower of Ruin [Top]","Location: Chamber of Extinction [Map]","Location: Chamber of Extinction [Main]","Location: Chamber of Extinction [Left Main]","Location: Chamber of Extinction [Magatama Left]","Location: Chamber of Extinction [Magatama Right]","Location: Chamber of Extinction [Ankh Upper]","Location: Chamber of Birth [West Entrance]","Location: Chamber of Birth [Skanda]","Location: Chamber of Birth [Northeast]","Location: Chamber of Birth [Southeast]","Location: Twin Labyrinths [Loop]","Location: Twin Labyrinths [Lower]","Location: Twin Labyrinths [Poison 1]","Location: Twin Labyrinths [Poison 2]","Location: Twin Labyrinths [Poseidon]","Location: Endless Corridor [1F]","Location: Endless Corridor [2F]","Location: Endless Corridor [5F]","Location: Dimensional Corridor [Lower]","Location: Dimensional Corridor [Grail]","Location: Shrine of the Mother [Main]","Location: Shrine of the Mother [Lower]","Location: Shrine of the Mother [Seal]","Location: Shrine of the Mother [Map]","Location: Gate of Time [Mausoleum Lower]","Location: Gate of Time [Mausoleum Upper]","Location: Gate of Time [Guidance]","Location: Gate of Time [Surface]"]
listofInitialChecks=[]
NodesNotifyChart={}

def luaWriter(someSimpleRequirementList, filePoint):
	luaString = ""
	for someKey, listOfRequirements in someSimpleRequirementList.items():
		if ":" not in someKey or "Transition:" in someKey or "Door:" in someKey:  
		 #to Distinguish item to get and item location on the map
			someKey = "Vanilla"+someKey
		sanitizedKey = common.sanitize(someKey)
		if someKey not in listofNodes:
			luaString = luaString+ "NodeStatusArray[\""+sanitizedKey+"\"]=false\n"
			luaString = luaString+ "NodeStatusArray[\""+sanitizedKey+"MinReqs\"]=false\n"
			listofNodes.append(someKey)
			NodesNotifyChart[someKey]=[]
			NodesNotifyChart[someKey + "MinReqs"]=[]
		for someRequirement in listOfRequirements:
			for someSomeRequirement in someRequirement:
				sanitizedRequirement = common.sanitize(someSomeRequirement)
				if "!" in someSomeRequirement or someSomeRequirement == "StatePreEscape":
						luaString = luaString+ "NodeStatusArray[\""+sanitizedRequirement+"\"]=true\n"
						luaString = luaString+ "NodeStatusArray[\""+sanitizedRequirement+"MinReqs\"]=true\n"
						listofNodes.append(someSomeRequirement)
						NodesNotifyChart[someSomeRequirement]=[]
						NodesNotifyChart[someSomeRequirement + "MinReqs"]=[]
				elif ":" in someSomeRequirement and "Defeated" in someSomeRequirement:
					done=0
					for Guardian in listOfGuardians: #Hack to put Guardians on item Grid
						if Guardian in someSomeRequirement and "Children" not in someSomeRequirement: #Distinsuish Tiamat and her Children
							done=1
							if someSomeRequirement not in listofNodes: 
								luaString = luaString+ "NodeStatusArray[\""+Guardian+"\"]=false\n"
								luaString = luaString+ "NodeStatusArray[\""+Guardian+"MinReqs\"]=false\n"
								listofNodes.append(someSomeRequirement)
								NodesNotifyChart[Guardian]=[]
								NodesNotifyChart[Guardian + "MinReqs"]=[]
								listofInitialChecks.append(Guardian)
					if not done:
						if someSomeRequirement not in listofNodes: 
							luaString = luaString+ "NodeStatusArray[\""+sanitizedRequirement+"\"]=false\n"
							luaString = luaString+ "NodeStatusArray[\""+sanitizedRequirement+"MinReqs\"]=false\n"
							listofNodes.append(someSomeRequirement)
							NodesNotifyChart[someSomeRequirement]=[]
							NodesNotifyChart[someSomeRequirement + "MinReqs"]=[]
				elif ":" in someSomeRequirement and "Setting:" not in someSomeRequirement and "Boost:" not in someSomeRequirement and "Transition:" not in someSomeRequirement and "Door:" not in someSomeRequirement and "NPCI" not in someSomeRequirement: #Boost, Settings are in the item Grid
					if someSomeRequirement not in listofNodes:
						luaString = luaString+ "NodeStatusArray[\""+sanitizedRequirement+"\"]=false\n"
						luaString = luaString+ "NodeStatusArray[\""+sanitizedRequirement+"MinReqs\"]=false\n"
						listofNodes.append(someSomeRequirement)
						NodesNotifyChart[someSomeRequirement]=[]
						NodesNotifyChart[someSomeRequirement + "MinReqs"]=[]
				else:	#These are the items on the item grids
					if someSomeRequirement not in listofNodes:
						luaString = luaString+ "NodeStatusArray[\""+sanitizedRequirement+"\"]=false\n"
						luaString = luaString+ "NodeStatusArray[\""+sanitizedRequirement+"MinReqs\"]=false\n"
						listofNodes.append(someSomeRequirement)
						NodesNotifyChart[someSomeRequirement]=[]
						NodesNotifyChart[someSomeRequirement + "MinReqs"]=[]
						listofInitialChecks.append(someSomeRequirement)
	for Guardian in listOfGuardians:
		luaString = luaString + "NodeStatusArray[\"Event" + Guardian + "Defeated\"] = false\n"
		luaString = luaString + "NodeStatusArray[\"Event" + Guardian + "DefeatedMinReqs\"] = false\n"
	for node in listofNodes:
		if "Transition:" in node and "W1" not in node: #Make Exit: (some transition) checks for Transition: (some transition) except for one-ways(Warp)
			if ("Exit: "+node[12:]) in listofNodes:
				if ("Exit: "+node[12:]) not in someSimpleRequirementList:
					someSimpleRequirementList["Exit: "+node[12:]]=[]
				someSimpleRequirementList["Exit: "+node[12:]].append([node])
				NodesNotifyChart[node].append("Exit: "+node[12:])
				NodesNotifyChart[node+ "MinReqs"].append("Exit: "+node[12:]+ "MinReqs")
		if "Door:" in node and "B8" not in node: #Same for door, other than the one way (B8)
			if ("Exit: Door "+node[6:]) in listofNodes:
				if ("Exit: Door "+node[6:]) not in someSimpleRequirementList:
					someSimpleRequirementList["Exit: Door "+node[6:]]=[]
				someSimpleRequirementList["Exit: Door "+node[6:]].append([node])
				NodesNotifyChart[node].append("Exit: Door "+node[6:])
				NodesNotifyChart[node+ "MinReqs"].append("Exit: Door "+node[6:]+ "MinReqs")
	#for tr in listOfTransitions:
	#	if ("Transition: "+tr) not in listofNodes:
	#		luaString = luaString+ "NodeStatusArray[\""+common.sanitize("Transition: "+tr)+"\"]=false\n"
	#		listofNodes.append("Transition: "+tr)
	#		NodesNotifyChart["Transition: "+tr]=[]
	#		listofInitialChecks.append("Transition: "+tr)
	luaString = luaString + "InitialChecks = {}\n"
	for Items in listofInitialChecks:
		sanitizedItems = common.sanitize(Items)
		luaString = luaString + "InitialChecks [\"" + sanitizedItems + "\"]=true\n"
		luaString = luaString + "InitialChecks [\"" + sanitizedItems + "MinReqs\"]=true\n"
	#luaString = luaString + "InitialChecks [\"LocationSurfaceMain\"]=true\n"
	#luaString = luaString + "InitialChecks [\"ExitSurfaceR1\"]=true\n"
	for OrbCount in range(1,11):
		luaString = luaString + "InitialChecks [\"SacredOrb"+str(OrbCount)+"\"]=true\n"
		luaString = luaString + "InitialChecks [\"SacredOrb"+str(OrbCount)+"MinReqs\"]=true\n"
	for someKey, listOfRequirements in someSimpleRequirementList.items():	
		if ":" not in someKey or "Transition:" in someKey or "Door:" in someKey:
			someKey = "Vanilla"+someKey
		for someRequirement in listOfRequirements:
			for someSomeRequirement in someRequirement:
				if ":" in someSomeRequirement and "Defeated" in someSomeRequirement:
					done=0
					for Guardian in listOfGuardians:
						if Guardian in someSomeRequirement and "Children" not in someSomeRequirement:
							done=1
							if someKey not in NodesNotifyChart[Guardian]:
								NodesNotifyChart[Guardian].append(someKey)
								NodesNotifyChart[Guardian + "MinReqs"].append(someKey + "MinReqs")
					if not done:
						if someKey not in NodesNotifyChart[someSomeRequirement]:
							NodesNotifyChart[someSomeRequirement].append(someKey)
							NodesNotifyChart[someSomeRequirement + "MinReqs"].append(someKey + "MinReqs")
				elif ":" in someSomeRequirement and "Setting" not in someSomeRequirement and "Boost" not in someSomeRequirement and "NPCI" not in someSomeRequirement:
					if someKey not in NodesNotifyChart[someSomeRequirement]:
						NodesNotifyChart[someSomeRequirement].append(someKey)
						NodesNotifyChart[someSomeRequirement + "MinReqs"].append(someKey + "MinReqs")
				else:
					if someKey not in NodesNotifyChart[someSomeRequirement]:
						NodesNotifyChart[someSomeRequirement].append(someKey)
						NodesNotifyChart[someSomeRequirement + "MinReqs"].append(someKey + "MinReqs")
	for node in listofNodes:
		if "!" in node:
			NodesNotifyChart[node[1:]].append(node)
			NodesNotifyChart[node[1:] + "MinReqs"].append(node + "MinReqs")
		#if "Exit:" in node:
		#	for location in listofItemizeLocations:
		#		if location in node:
		#			NodesNotifyChart["Location:"+node[5:]].append(node)


	luaString = luaString + "NotificationChart={}\n"
	#pprint.pprint(NodesNotifyChart)
	for Notifier, Notified in NodesNotifyChart.items():
		luaString = luaString + "NotificationChart[\"" + common.sanitize(Notifier) + "\"] = {"
		for N in Notified:
			luaString = luaString + "\"" +common.sanitize(N)+"\","
		luaString = luaString + "}\n"
	for Guardian in listOfGuardians:
		luaString = luaString + "NotificationChart[\"Event" + Guardian + "Defeated\"] = {}\n"
		luaString = luaString + "NotificationChart[\"Event" + Guardian + "DefeatedMinReqs\"] = {}\n"
	luaString = luaString + "CheckFunctionTable={}\n"
	logicDict = {}
	for someKey, listOfRequirements in someSimpleRequirementList.items():	
		if ":" not in someKey or "Transition:" in someKey or "Door:" in someKey:
			someKey = "Vanilla"+someKey
		sanitizedKey = common.sanitize(someKey)
		logicString = '(' # "CheckFunctionTable[\""+sanitizedKey+"\"] = function() return ("
		listOfConditions = []
		for someRequirement in listOfRequirements:
			conditions = []
			for someSomeRequirement in someRequirement:
				if ":" in someSomeRequirement and "Defeated" in someSomeRequirement:
					done=0
					for Guardian in listOfGuardians:
						if Guardian in someSomeRequirement and "Children" not in someSomeRequirement:
							done=1
							conditions.append("NodeStatusArray[\""+Guardian+"\"]")
					if not done:
						conditions.append("NodeStatusArray[\""+common.sanitize(someSomeRequirement)+"\"]")
				else:
					conditions.append("NodeStatusArray[\""+common.sanitize(someSomeRequirement)+"\"]")
			if conditions:
				listOfConditions.append(conditions)
		#if sanitizedKey == "LocationSurfaceMain" or sanitizedKey == "ExitSurfaceMain":
		#	logicString = logicString + "true)"
		if not listOfConditions :
			logicString = logicString + "true)"
		else:
			logicString = logicString + " or ".join("("+(" and ".join(inner))+")" for inner in listOfConditions) + ")"
		logicDict[sanitizedKey] = logicString

	for key, value in logicDict.items():
		simple = common.simplifyRule(value)
		luaString = luaString + "CheckFunctionTable[\"" + key + "\"] = function() return (" + simple + ") end\n"
		sanitizedValue = common.simplifyRule(common.sanitizeRequirementsForIntendedLogic( value ))
		luaString = luaString + "CheckFunctionTable[\"" + key + "MinReqs\"] = function() return (" + sanitizedValue + ") end\n"

	for item in listofInitialChecks:
		luaString = luaString + "CheckFunctionTable[\""+common.sanitize(item)+"\"] = function() return Tracker:ProviderCountForCode(\"" + common.sanitize(item) + "\") >= 1 end\n"
		luaString = luaString + common.sanitizeRequirementsForIntendedLogic("CheckFunctionTable[\""+common.sanitize(item)+"\"] = function() return Tracker:ProviderCountForCode(\"" + common.sanitize(item) + "\") >= 1 end\n")
	for OrbCount in range(1,11):
		luaString = luaString + "CheckFunctionTable[\"SacredOrb"+str(OrbCount)+"\"] = function() return Tracker:ProviderCountForCode(\"SacredOrb\") >= "+str(OrbCount)+" end\n"
		luaString = luaString + "CheckFunctionTable[\"SacredOrb"+str(OrbCount)+"MinReqs\"] = function() return Tracker:ProviderCountForCode(\"SacredOrb\") >= "+str(OrbCount)+" end\n"
	for node in listofNodes:
		if "!" in node:
			luaString = luaString + "CheckFunctionTable[\""+common.sanitize(node)+"\"] = function() return not NodeStatusArray[\""+common.sanitize(node[1:])+"\"] end\n"
			luaString = luaString + "CheckFunctionTable[\""+common.sanitize(node)+"MinReqs\"] = function() return not NodeStatusArray[\""+common.sanitize(node[1:])+"MinReqs\"] end\n"

	#pprint.pprint(someSimpleRequirementList["Exit: Surface R1"])
	for someKey, listOfRequirements in someSimpleRequirementList.items():	
		if ":" not in someKey or "Transition:" in someKey or "Door:" in someKey:
			someKey = "Vanilla"+someKey
		sanitizedKey = common.sanitize(someKey)
		if "Vanilla" in someKey or "Coin:" in someKey or "Trap:" in someKey  or "Transition:" in someKey or "Location:" in someKey or "NPCL:" in someKey: 
		#adding Locations for visible but not obtainable locations
			if sanitizedKey == "VanillaAngelShield":
				luaString = luaString + "function " + sanitizedKey + "()\n\tUpdateAvailability()\n\treturn NodeStatusArray[\"" + sanitizedKey +"\"]\nend\n\n"
				luaString = luaString + "function " + sanitizedKey + "MinReqs()\n\treturn NodeStatusArray[\"" + sanitizedKey +"MinReqs\"]\nend\n\n"
			else:
				luaString = luaString + "function " + sanitizedKey + "()\n\treturn NodeStatusArray[\"" + sanitizedKey +"\"]\nend\n\n"
				luaString = luaString + "function " + sanitizedKey + "MinReqs()\n\treturn NodeStatusArray[\"" + sanitizedKey +"MinReqs\"]\nend\n\n"
		if "Event:" in someKey and "Defeated" in someKey:
			for Guardian in listOfGuardians:
				if Guardian in someKey and "Children" not in someKey:
					luaString = luaString + "function " + sanitizedKey + "()\n\treturn NodeStatusArray[\"" + sanitizedKey +"\"]\nend\n\n"
					luaString = luaString + "function " + sanitizedKey + "MinReqs()\n\treturn NodeStatusArray[\"" + sanitizedKey +"MinReqs\"]\nend\n\n"
	luaString = luaString + "function TransitionInfernoW1()\n\treturn NodeStatusArray[\"LocationInfernoCavernLava()\"]\nend\n\n"
	luaString = luaString + "function TransitionInfernoW1MinReqs()\n\treturn NodeStatusArray[\"LocationInfernoCavernLava()\"]\nend\n\n"
	luaString = luaString + "function TransitionGoddessW1()\n\treturn NodeStatusArray[\"LocationToweroftheGoddessLamp()\"]\nend\n\n"
	luaString = luaString + "function TransitionGoddessW1MinReqs()\n\treturn NodeStatusArray[\"LocationToweroftheGoddessLamp()\"]\nend\n\n"

	luaString=luaString+ common.updateEntranceAvailability
	#	luaString = luaString + "processing" + common.sanitize(someKey) + " = false\n"
	#	luaString = luaString + "function " + common.sanitize(someKey) + "()\n\tif processing" + common.sanitize(someKey) + " then\n\t\treturn 0\n\tend\n\tprocessing" + common.sanitize(someKey) + " = true\n\tif ("
	#	listOfConditions = []
	#	for someRequirement in listOfRequirements:
	#		conditions = []
	#		for someSomeRequirement in someRequirement:
	#			if ":" in someSomeRequirement and "Defeated" in someSomeRequirement:
	#				for Guardian in listOfGuardians:
	#					if Guardian in someSomeRequirement:
	#						conditions.append("Tracker:ProviderCountForCode(\"" + Guardian + "\") >= 1")
	#			elif ":" in someSomeRequirement and "Setting" not in someSomeRequirement and "Boost" not in someSomeRequirement:
	#				conditions.append(common.sanitize(someSomeRequirement) + "() == 1")
	#			else:
	#				conditions.append("Tracker:ProviderCountForCode(\"" + common.sanitize(someSomeRequirement) + "\") >= 1")
	#				if [someSomeRequirement, common.sanitize(someSomeRequirement)] not in listOfItems:
	#					listOfItems.append([someSomeRequirement, common.sanitize(someSomeRequirement)])
	#		listOfConditions.append(conditions)
	#	luaString = luaString + " or ".join("("+(" and ".join(inner))+")" for inner in listOfConditions) + ") then\n\t\tprocessing" + common.sanitize(someKey) + " = false\n\t\treturn 1\n\tend\n\tprocessing" + common.sanitize(someKey) + " = false\n\treturn 0\nend\n\n"
	filePoint.write(luaString)


requirementList = []
current_path = os.path.dirname(os.path.realpath(__file__))
logic_file = os.path.join(current_path, "..", "..", "scripts", "logic_entrance.lua")
if os.path.exists(logic_file):
	os.remove(logic_file)
f = open(logic_file, "a")
luaString = "NodeStatusArray={}\n"
f.write(luaString)
masterList = buildMasterList()
# masterListDebug = open("debug.json", "w")
# masterListDebug.write(json.dumps(masterList, indent="\t"))
# masterListDebug.close()
masterList["Location: Surface [Main]"].append(["startingAreaLocationIsSurface"])
masterList["Location: Gate of Illusion [Grail]"].append(["startingAreaLocationIsIllusion"])
masterList["Location: Gate of Guidance [Main]"].append(["startingAreaLocationIsGuidance"])
masterList["Location: Mausoleum of the Giants"].append(["startingAreaLocationIsMausoleum"])
masterList["Location: Inferno Cavern [Main]"].append(["startingAreaLocationIsInferno"])
masterList["Location: Twin Labyrinths [Upper Grail]"].append(["startingAreaLocationIsTwinF"])
masterList["Location: Twin Labyrinths [Upper Left]"].append(["startingAreaLocationIsTwinF"]) #Elevator on by default	
masterList["Location: Endless Corridor [1F]"].append(["startingAreaLocationIsEndless"])
masterList["Location: Twin Labyrinths [Lower]"].append(["startingAreaLocationIsTwinB"])
masterList["Location: Gate of Time [Surface]"].append(["startingAreaLocationIsTime"])
masterList["Location: Graveyard of the Giants [Grail]"].append(["startingAreaLocationIsGraveyard"])
masterList["Location: Tower of the Goddess [Grail]"].append(["startingAreaLocationIsGoddess"])
masterList["Location: Chamber of Birth [West Entrance]"].append(["startingAreaLocationIsBirth"])
masterList["Location: Temple of the Sun [Grail]"].append(["startingAreaLocationIsSun"])
masterList["Location: Spring in the Sky [Main]"].append(["startingAreaLocationIsSpring"])
masterList["Location: Chamber of Extinction [Main]"].append(["startingAreaLocationIsExtinction"])
masterList["Location: Temple of Moonlight [Grail]"].append(["startingAreaLocationIsMoonlight"])
masterList["Attack: Pistol"].append(["startingWeaponPistol"])
luaWriter(masterList, f)
f.close()

location_file = os.path.join(current_path, "..", "..", "locations", "locations_entrances.json")
if os.path.exists(location_file):
	os.remove(location_file)
f = open(location_file, "a")
locationJson = {}
locationJson["name"] = "All locations"
locationJson["chest_unopened_img"] = "images/item_closedChest.png"
locationJson["chest_opened_img"] = "images/item_openedChest.png"
locationJson["children"] = []
index = 0
for someLocation, someDetails in locationTable.items():
	someCrap = {}
	someCrap["name"] = locationTable[someLocation]["sectionName"]
	sanitizedLocation = common.sanitize(someLocation)
	target = "$"
	if ":" not in someLocation or "Transition:" in  someLocation:
		target = "$Vanilla"
	
	target = target + sanitizedLocation	
		#someCrap["access_rules"] = ["[" + target + "], " + target + "MinReqs"]

	if ":" not in someLocation or "Transition:" in  someLocation :
		someCrap["item_count"] = 1
		someCrap["access_rules"] = ["[" + target + "], " + target + "MinReqs"]
	#Shop Items only appear in NonrnadomNPC setting
	elif "Shop" in someLocation:
		someCrap["item_count"] = 3
		someCrap["access_rules"] = ["[" + target + "], " + target + "MinReqs, SettingNonrandomNPCs"]
	elif "NPCL:" in someLocation:
		someCrap["item_count"] = 1
		someCrap["access_rules"] = ["[" + target + "], " + target + "MinReqs, SettingRandomNPCs"]
	elif "TransitionLocation" in someLocation: #Make Transition hosts location, always visible
		#someCrap["item_count"] = 1
		someCrap["access_rules"]=["{}"]
	elif "RuinDoor" in someLocation:
		someCrap["item_count"] = 1
		someCrap["access_rules"] = ["{$Location" + sanitizedLocation[8:] +"}"]
	else:
		someCrap["item_count"] = 1
		someCrap["access_rules"] = ["[" + target + "], " + target + "MinReqs"]
	if "VisibleBeforeAvailable" in someDetails:
		someCrap["access_rules"].append("{[$"+locationTable[someLocation]["VisibleBeforeAvailable"]+"], $"+locationTable[someLocation]["VisibleBeforeAvailable"]+"MinReqs}")
	
	if "hostedItem" in someDetails:
		someCrap["hosted_item"] = locationTable[someLocation]["hostedItem"]
		someCrap["item_count"] = 0
	if "isChild" not in someDetails:
		someItem = {}
		someItem["name"] = locationTable[someLocation]["locationName"]
		someItem["map_locations"] = []
		subMap = {}
		subMap["map"] = locationTable[someLocation]["mapName"]
		subMap["x"] = locationTable[someLocation]["subMapXY"][0]
		subMap["y"] = locationTable[someLocation]["subMapXY"][1]
		someItem["map_locations"].append(subMap)
		worldMap = {}
		worldMap["map"] = "world"
		worldMap["x"] = round(locationTranslation[locationTable[someLocation]["mapName"]][0] + (locationTable[someLocation]["subMapXY"][0] * locationTranslation[locationTable[someLocation]["mapName"]][2]))
		worldMap["y"] = round(locationTranslation[locationTable[someLocation]["mapName"]][1] + (locationTable[someLocation]["subMapXY"][1] * locationTranslation[locationTable[someLocation]["mapName"]][2]))
		someItem["map_locations"].append(worldMap)
		someItem["sections"] = []

		someItem["sections"].append(someCrap)
		locationJson["children"].append(someItem)
		index = index + 1
	else:
		locationJson["children"][index - 1]["sections"].append(someCrap)

f.write(json.dumps([locationJson], indent="\t"))
f.close()
