--Toggle item: the seals themselves, added in an array for reference.




ToggleSeals={}

ToggleItem = CustomItem:extend()

function ToggleItem:init(name, code, imagePath,index)
    self:createItem(name)
    self.code = {}
    self.code[code]=true
    self:setProperty("active", false)
    self.activeImage = ImageReference:FromPackRelativePath(imagePath)
    self.disabledImage = ImageReference:FromImageReference(self.activeImage, "@disabled")
    self.ItemInstance.PotentialIcon = self.activeImage
    ToggleSeals[index]=self

    self:updateIcon()    
end

function ToggleItem:setActive(active)
    self:setProperty("active", active)
end

function ToggleItem:getActive()
    return self:getProperty("active")
end

function ToggleItem:updateIcon()
    if self:getActive() then
        self.ItemInstance.Icon = self.activeImage
    else
        self.ItemInstance.Icon = self.disabledImage
    end
end

function ToggleItem:onLeftClick()
    self:setActive(true)
end

function ToggleItem:onRightClick()
    self:setActive(false)
end

function ToggleItem:canProvideCode(code)
    if self.code[code]~=nil then
        return true
    else
        return false
    end
end

function ToggleItem:providesCode(code)
    if self.code[code]~=nil and self:getActive() then
        return 1
    end
    return 0
end

function ToggleItem:addCode(code)
    self.code[code]=true
end
function ToggleItem:removeCode(code)
    self.code[code]=nil
end

function ToggleItem:advanceToCode(code)
    if code == nil or self.code[code]~=nil then
        self:setActive(true)
    end
end

function ToggleItem:save()
    local saveData = {}
    saveData["active"] = self:getActive()
    return saveData
end

function ToggleItem:load(data)
    if data["active"] ~= nil then
        self:setActive(data["active"])
    end
    return true
end

function ToggleItem:propertyChanged(key, value)
    self:updateIcon()
end
local ToggleData = {

    
    -- murals
    [1]={
        ["name"] = "OriginSeal",
        ["code"] = "originseal",
        ["image"] = "images/Icon_originseal.png"
    },
    
        [2]={
        ["name"] = "BirthSeal",
        ["code"] = "birthseal",
        ["image"] = "images/Icon_birthseal.png"
    },    
    [3]={
        ["name"] = "LifeSeal",
        ["code"] = "lifeseal",
        ["image"] = "images/Icon_lifeseal.png"
    },    
    [4]={
        ["name"] = "DeathSeal",
        ["code"] = "deathseal",
        ["image"] = "images/Icon_deathseal.png"
    },
}

for i,data in pairs(ToggleData) do
    local newItem = ToggleItem(data["name"], data["code"], data["image"],i)
end